/*	Filename:Region.h							*/
/************************************************/
/*												*/
/*			DELTA SOFT VCL Component			*/
/*												*/
/*				for VCL	Ver.5.0					*/
/*												*/
/*		[WRg[R|[lg	*/
/*												*/
/*		Copyright(C),1997,2000 by DELTA SOFT	*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*						`						*/
/*----------------------------------------------*/

#ifndef RegionH
#define RegionH
/*
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
*/
/*----------------------------------------------*/
/*			dsvRegionNX						*/
/*----------------------------------------------*/

class PACKAGE dsvRegion : public TComponent
{
private:
	HRGN		FRgn;
	TImage*		FImage;
	TColor		FTransparentColor;

protected:
	void __fastcall	SetTransparentColor(TColor color);
//	TColor	__fastcall	GetTransparentColor(void);

public:
//	__fastcall	dsvRegion(TComponent* Owner);
	__fastcall	dsvRegion(TImage* Image);
	__fastcall	~dsvRegion();
	void __fastcall	Add(int x,int y,int Width,int Height);
	void __fastcall	Clear(void);
	void __fastcall	Create(void);
	void __fastcall	Set(void);
	void __fastcall	Delete(void);

	__property	HRGN	Region={read=FRgn};
	
__published:
	__property	TImage*	Image={read=FImage,write=FImage};
	__property	TColor	TransparentColor={read=FTransparentColor,write=SetTransparentColor};
};

#endif

/*****	End	*****/