/*	Filename:FindFile.h							*/
/************************************************/
/*												*/
/*			t@CNX					*/
/*												*/
/*					Ver.6.00  					*/
/*												*/
/*		Copyright 1997-2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef FindFileH
#define FindFileH

/*----------------------------------------------*/
/*				TFindFileNX					*/
/*----------------------------------------------*/

class	TFindFile:private	WIN32_FIND_DATA
{
private:
	HANDLE		FHandle;
	DWORD		FMask;
	bool		FCurDir;
	bool		FFindFirst;
	AnsiString	FFindPath;
	AnsiString	FPath;

protected:
	void __fastcall	Init(void);
	bool __fastcall	IsEnabled(void);
	AnsiString __fastcall	GetFileName();
	AnsiString __fastcall	GetShortFileName();
	AnsiString __fastcall	GetPath(void);
	AnsiString	GetFullPath(AnsiString Path);

public:

	__fastcall	TFindFile(void);
	__fastcall	TFindFile(AnsiString Path);
	__fastcall	~TFindFile(void);

	void __fastcall	Close(void);
	bool __fastcall	Research(AnsiString Path);
	bool __fastcall	Find(DWORD mask);
	bool __fastcall Find(void);

	__fastcall	operator	WIN32_FIND_DATA();

	__property	HANDLE		Handle={read=FHandle};
	__property	bool		Enabled={read=IsEnabled};
	__property	DWORD		Mask={read=FMask,write=FMask};
	__property	bool		CurDir={read=FCurDir,write=FCurDir};
	__property	DWORD		FileAtr={read=dwFileAttributes};
	__property	FILETIME	CreationTime={read=ftCreationTime};
	__property	FILETIME	AccessTime={read=ftLastAccessTime};
	__property	FILETIME	LastWriteTime={read=ftLastWriteTime};
	__property	DWORD		FileSizeHigh={read=nFileSizeHigh};
	__property	DWORD		FileSizeLow={read=nFileSizeLow};
	__property	DWORD		Reserved0={read=dwReserved0};
	__property	DWORD		Reserved1={read=dwReserved1};
	__property	AnsiString	FileName={read=GetFileName};
	__property	AnsiString	ShortFileName={read=GetShortFileName};
	__property	AnsiString	Path={read=FPath};
	__property	AnsiString	FindPath={read=FFindPath,write=Research};
};

#endif

/*****	End	*****/
