/*	Filename:Meter.cpp							*/
/************************************************/
/*												*/
/*				WXyAipl+ 				*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	[^[W[				*/
/*                             					*/
/*		Copyright 2001,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "Meter.h"

#pragma package(smart_init)

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				 								*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				TMeterNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TMeter::TMeter(TPanel *Panel)
{
	FPanel=Panel;
	FType=mtLevel;
}

/*****  pl̃x[x̕擾  *****/

int __fastcall  TMeter::GetPanelBevelWidth(void)
{
	int     bw=0;
	if (FPanel->BevelInner != bvNone)
	then    bw+=FPanel->BevelWidth;
	if (FPanel->BevelOuter != bvNone)
	then    bw+=FPanel->BevelWidth;

	return(bw);
}

/*****	Bar쐬	*****/
/*
	FDir:	
		0=H/L,4=L/H
		1=L/H,5=H/L
		2=H/L,6=L/H
		3=L/H,7=H/L
*/
void __fastcall	TMeter::MakeBand(int dir,int band,int bands)
{
	int     bw=GetPanelBevelWidth();
	int		cw=FPanel->Width-bw*2;
	int		ch=FPanel->Height-bw*2;
	int		Left,Top,Bottom;
	int		n,add;
	int		Width,Height;
//	TColor	cl;
	int		i;

	FDir=dir & 0x07;
	FBands=bands;
	FBand=band;

	if (FType==mtGraphics)
	then {
		if (FImage==NULL)
		then	FImage=new TImage(FPanel);
		FImage->Parent=FPanel;
		FImage->Cursor=crHandPoint	;
		FImage->ParentShowHint=true;
		FImage->ShowHint=true;
		FImage->Tag=FPanel->Tag+((FBand+1)<<12);
		FImage->OnClick=FPanel->OnClick;
		FImage->OnDblClick=FPanel->OnDblClick;
		if ((FDir & 1)==0)								//0/4:,2/6:
		then {
			Height=ch/FBands;
			FImage->Left=bw;
			if (FDir & 4)
			then	FImage->Top=bw+(ch-Height*FBands)/2+FBand*Height;
			else	FImage->Top=bw+(ch-Height*FBands)/2+(FBands-1-FBand)*Height;
			FImage->Width=cw;
			FImage->Height=ch/FBands;
		}
		else {
			Width=cw/FBands;
			if (FDir & 4)
			then	FImage->Left=bw+(cw-Width*FBands)/2+(FBands-1-FBand)*Width;
			else	FImage->Left=bw+(cw-Width*FBands)/2+FBand*Width;
			FImage->Top=bw;
			FImage->Width=cw/FBands;
			FImage->Height=ch;
		}
		SetLevel(0);
		return;
	}
	if (FImage)
	then {
		delete	FImage;
		FImage=NULL;
	}

	if ((FDir & 1)==0)								//0/4:,2/6:
	then {
		Width=cw/10;
		Height=ch/FBands;
		Left=bw+(cw-Width*10)/2;
		if (FDir & 4)
		then	Top=bw+(ch-Height*FBands)/2+FBand*Height;
		else	Top=bw+(ch-Height*FBands)/2+(FBands-1-FBand)*Height;
		Bottom=Top+Height*(FBands-1);
		if (FType==mtMask)
		then	cw=Width;
		else	cw=Width-1;
		if (cw<=0)
		then	cw=1;
		if (FType==mtPeak)
		then {
			cw=1;
			if ((FDir & 2)==0)						//
			then	Left+=Width-1;
		}
		else if (FType != mtMask)
		then {
			if (FDir & 2)							//
			then	Left++;
		}
		if (FType != mtMask)
		then {
			switch(FBands)
			{
				case 1:
					ch=Height;
					break;
				case 2:
					ch=Height-1;
					if (((FDir & 4) AND (FBand==1))
						OR (((FDir & 4)==0) AND (FBand==0)))
					then	Top+=1;
					break;
				default:
					ch=Height-2;
					Top+=1;
					break;
			}
		}
	}
	else { 											//1/5:,3/7:
		Width=cw/FBands;
		Height=ch/10;
		if (FDir & 4)
		then	Left=bw+(cw-Width*FBands)/2+(FBands-1-FBand)*Width;
		else	Left=bw+(cw-Width*FBands)/2+FBand*Width;
		Top=bw+(ch-Height*10)/2;
		if (FType==mtPeak)
		then {
			ch=1;
			if (FDir & 2)						//
			then	Top+=Height-1;
		}
		else if (FType != mtMask)
		then {
			ch=Height-1;
			if (ch<=0)
			then	ch=1;
			else if ((FDir & 2)==0)				//
			then	Top+=1;
		}
		Bottom=Top+Height*9;
		if (FType != mtMask)
		then {
			switch(FBands)
			{
				case 1:
					cw=Width;
					break;
				case 2:
					cw=Width-1;
					if (((FDir & 4) AND (FBand==0))
						OR (((FDir & 4)==0) AND (FBand==1)))
					then	Left+=1;
					break;
				default:
					cw=Width-2;
					Left+=1;
					break;
			}
		}
	}
	if ((FDir & 3)<2)
	then {
		n=0;
		add=1;
	}
	else {
		n=9;
		add=-1;
	}

	for(i=0;	i<10;	i++)
	{
		if (FLabel[n]==NULL)
		then    FLabel[n]=new TLabel(FPanel);

		FLabel[n]->Parent=Panel;
		FLabel[n]->Caption="";
		FLabel[n]->AutoSize=false;
		if ((FDir & 1)==0)
		then {
			FLabel[n]->Left=Left+i*Width;
			FLabel[n]->Top=Top;
		}
		else {
			FLabel[n]->Left=Left;
			FLabel[n]->Top=Bottom-i*Height;
		}
		FLabel[n]->Height=ch;
		FLabel[n]->Width=cw;
		FLabel[n]->Color=FColor[i];
		FLabel[n]->Cursor=crHandCursor;
		FLabel[n]->ParentShowHint=true;
		FLabel[n]->ShowHint=true;
		FLabel[n]->Tag=FPanel->Tag+((FBand+1)<<12)+((i+1)<<8);
		FLabel[n]->OnClick=FPanel->OnClick;
		FLabel[n]->OnDblClick=FPanel->OnDblClick;
		FLabel[n]->Visible=false;

		n+=add;
	}
}

/*****	J[̐ݒ	*****/

void __fastcall	TMeter::SetColor(int Index,TColor c)
{
	FColor[Index]=c;
	if (FLabel[Index])
	then	FLabel[Index]->Color=c;
}

/*****  [^̕\  *****/

void __fastcall TMeter::SetLevel(int level)
{
	TColor		cl;
	int     	i;

	if (level<0)
	then	level=0;
	else if (level>10)
	then	level=10;


	if (FType==mtPeak)
	then {
		if (FLevel != level)
		then {
			if (FLevel>=1)
			then	FLabel[FLevel-1]->Visible=false;
			if (level>=1)
			then	FLabel[level-1]->Visible=true;
			FLevel=level;
		}
	}
	else if (FType==mtMask)
	then {
		FLevel=level;

		for(i=9;    i>=FLevel;  i--)
		{
			if (FLabel[i]->Color != FColor[i])
			then	FLabel[i]->Color=FColor[i];
			if (FLabel[i]->Visible==false)
			then	FLabel[i]->Visible=true;
		}
		for(;   i>=0;   i--)
		{
			if (Label[i]->Visible)
			then	Label[i]->Visible=false;
		}
	}
	else if (FType==mtGraphics)
	then {
		FLevel=level;

		if (FImageList)
		then {
			int	n=(FBand*11+FLevel) % FImageList->Count;
			FImageList->GetBitmap(n,FImage->Picture->Bitmap);
			FImage->Invalidate();
		}
	}
	else {
		FLevel=level;

		for(i=0;    i<FLevel;  i++)
		{
			if (FLabel[i]->Color != FColor[i])
			then	FLabel[i]->Color=FColor[i];
			if (FLabel[i]->Visible==false)
			then	FLabel[i]->Visible=true;
		}
		cl=FPanel->Color;
		for(;   i<10;   i++)
		{
			if (FVisibleControl)
			then {
				if (FLabel[i]->Visible==true)
				then	FLabel[i]->Visible=false;
			}
			else {
				if (FLabel[i]->Color != cl)
				then	FLabel[i]->Color=cl;
			}
		}
	}
}

/*****	End	*****/
