/*	Filename:main.h								*/
/************************************************/
/*												*/
/*					DSMPiCt{				*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include	"dsmp.h"
#include	"SMFKnife.h"
#include	"RCPCV.h"
#include <Dialogs.hpp>

/*----------------------------------------------*/
/*				TFormMainNX					*/
/*----------------------------------------------*/

class TFormMain : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TLabel *LabelTitle;
	TGroupBox *GroupBoxSMFKnife;
	TCheckBox *CheckBoxSMFKCh10;
	TCheckBox *CheckBoxSMFKBank;
	TCheckBox *CheckBoxSMFKMac;
	TCheckBox *CheckBoxSMFKCC64;
	TEdit *EditSMFKConfig;
	TButton *ButtonSMFKConfig;
	TCheckBox *CheckBoxSMFKnife;
	TCheckBox *CheckBoxRCPCV;
	TLabel *LabelVersion;
	TButton *BtnOK;
	TButton *BtnCancel;
	TOpenDialog *OpenDialog;
	TEdit *EditCache;
	TLabel *LabelCache;
	TButton *BtnHelp;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnOKClick(TObject *Sender);
	void __fastcall BtnCancelClick(TObject *Sender);
	void __fastcall ButtonSMFKConfigClick(TObject *Sender);
	void __fastcall BtnHelpClick(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TFormMain(TComponent* Owner);
};

/*----------------------------------------------*/
/*				TDSMPKnifeNX				*/
/*----------------------------------------------*/

class	TDSMPKnife:public TComponent
{
private:
	TDSMP		*FDSMP;
	TSMFKnife	*FSMFKnife;
	TRCPCV		*FRcpCv;
	TForm		*FPlayerForm;
	TDSMPMenu	*FPlayerMenuDSMPKnife;
	TDSMPMenu	*FPlayListMenuDSMPKnife;
	TDSMPMenu	*FPlayListMenuLine;
	TDSMPMenu	*FMenuSMFKnife;
	TDSMPMenu	*FMenuSMFKnifeConfig;

	TFormMain	*FormMain;
	AnsiString	FSMFKnifeConfig;
	AnsiString	FWorkDir;
	AnsiString	InFileName;
	AnsiString	OutFileName;
	unsigned	int	FFileCount;
	int			FCacheFiles;
	bool		FCacheCansel;
	bool		FSMFKErrMsg;

	TStringList	*InFileList;
	TStringList	*OutFileList;

protected:
	void __fastcall	DeleteCacheFiles(void);
	void __fastcall	SetSMFKnifeConfig(AnsiString S);
	AnsiString __fastcall	GetSMFKnifeConfig(AnsiString FileName);
	AnsiString __fastcall	GetSMFKnifeConfig(void);
	void __fastcall	DSMPKnifeMenuClick(TObject *Sender);
	void __fastcall	DSMPKnifeHelpClick(TObject *Sender);
	void __fastcall	DSMPKnifeAbortClick(TObject *Sender);
	void __fastcall	SMFKnifeDefaultOnClick(TObject *Sender);
	void __fastcall	SMFKnifeConfigOnClick(TObject *Sender);
	void __fastcall	SMFKnifeEtcOnClick(TObject *Sender);
	void __fastcall	DSMPOnDisplayMenu(TObject *Sender);
	void __fastcall	DSMPOnUser(TObject* Sender,DWORD Event,int Param);
	AnsiString	__fastcall	GetOutFileName(AnsiString FileName,bool &Exists);
	void __fastcall OnCallBack(TObject* Sender,int Value,bool &Abort);

public:
	__fastcall	TDSMPKnife(TComponent *Owner);
	__fastcall	~TDSMPKnife(void);
	void __fastcall	SaveIni(void);
	char* __fastcall	OpenPlayFile(char *filename);

	__property	TDSMP*		DSMP={read=FDSMP};
	__property	TSMFKnife*	SMFKnife={read=FSMFKnife};
	__property	TRCPCV*		RcpCv={read=FRcpCv};
	__property	int			CacheFiles={read=FCacheFiles,write=FCacheFiles};
	__property	AnsiString	SMFKnifeConfig={read=FSMFKnifeConfig,write=SetSMFKnifeConfig};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	TDSMPInterface	*DSMPIntf;
extern	TDSMPKnife		*DSMPKnife;
extern	int				Version;
extern	AnsiString		DllName;

#endif

/*****	End	*****/

