/*	Filename:SpeanaPanel.cpp					*/
/************************************************/
/*												*/
/*	   			vXyAipl+				*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	XyAiplW[		*/
/*                             					*/
/*		Copyright 2001,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "SpeanaPanel.h"

#pragma package(smart_init)


/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				 								*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				TSpeanaPanelNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TSpeanaPanel::TSpeanaPanel(Classes::TComponent* AOwner)
:TPanel(AOwner)
{
	Parent=(TWinControl*)AOwner;

	Cursor=crHandCursor;
	FType=mtLevel;
	Remake();
}

/*****	fXgN^	*****/

__fastcall	TSpeanaPanel::~TSpeanaPanel(void)
{
}

/*****	[^[̍Đݒ	*****/

void __fastcall	TSpeanaPanel::Remake(void)
{
	int		i;

	for(i=0;	i<10;	i++)
	{
		if (FLevelMeter[i])
		then	delete	FLevelMeter[i];
		FLevelMeter[i]=new TMeter(this);
		FLevelMeter[i]->Type=FType;
		FLevelMeter[i]->ImageList=FImageList;
		FLevelMeter[i]->MakeBand(FDir,i,10);
		if (FImage)
		then	FLevelMeter[i]->VisibleControl=true;

		if (FPeakMeter[i])
		then	delete	FPeakMeter[i];
		FPeakMeter[i]=new TMeter(this);
		FPeakMeter[i]->Type=mtPeak;
		FPeakMeter[i]->MakeBand(FDir,i,10);
	}
}

/*****	xJ[̎擾	*****/

TColor __fastcall	TSpeanaPanel::GetLevelColor(int Index)
{
	return(FLevelMeter[0]->Color[Index]);
}

/*****	xJ[̐ݒ	*****/

void __fastcall	TSpeanaPanel::SetLevelColor(int Index,TColor c)
{
	int		i;

	for(i=0; 	i<10;	i++)
	{
		FLevelMeter[i]->Color[Index]=c;
		FPeakMeter[i]->Color[Index]=c;
	}
}

/*****	s[N\^Cv̐ݒ	*****/

void __fastcall	TSpeanaPanel::SetPeakType(TPeakType Type)
{
	int		i;

	FPeakType=Type;

	Clear();
}

/*****	x̎擾	*****/

int __fastcall	TSpeanaPanel::GetLevel(int Index)
{
	return(FLevelMeter[Index]->Level);
}

/*****	x̐ݒ	*****/

void __fastcall	TSpeanaPanel::SetLevel(int Index,int level)
{
	int		d,n;

	FLevelMeter[Index]->Level=level;

	if ((FPeakType==ptDisable) OR (FPeakType==ptNone))
	then	return;

	d=FPeakMeter[Index]->Level;
	if (level>=d)
	then {
		d=level;
		if (FPeakType==ptHold)
		then    FPeakMeter[Index]->Count=16;			//߰ΰ ŏ̑҂
		else    FPeakMeter[Index]->Count=8;				//߰ި
	}
	else if (d)
	then {
		n=FPeakMeter[Index]->Count-1;  					//҂޸
		if (n<=0)
		then {
			if (FPeakType==ptHold)     		     	    //߰ΰ
			then {
				d=level;	                       		//Vl
				n=8;
			}
			else { 										//߰ި
				d--;                            		//޳
				n=2;
			}
		}
		FPeakMeter[Index]->Count=n;
	}

	if (d>10)
	then d=10;
	FPeakMeter[Index]->Level=d;
}

/*****	NA	*****/

void __fastcall	TSpeanaPanel::Clear(void)
{
	int		i;

	for(i=0;	i<10;	i++)
	{
		FPeakMeter[i]->Level=0;
		FLevelMeter[i]->Level=0;
	}
}

/*****	E]	*****/

void __fastcall	TSpeanaPanel::MirrorH(Graphics::TBitmap *bm)
{
	int		w=bm->Width;
	int		w2=w/2;
	int		h=bm->Height;
	int		x,y,x2;
	TColor	c;

	for(y=0;	y<h;	y++)
	{
		for(x=0;	x<w2;	x++)
		{
			x2=w-x-1;
			c=bm->Canvas->Pixels[x][y];
			bm->Canvas->Pixels[x][y]=bm->Canvas->Pixels[x2][y];
			bm->Canvas->Pixels[x2][y]=c;
		}
	}
}

/*****	㉺]	*****/

void __fastcall	TSpeanaPanel::MirrorV(Graphics::TBitmap *bm)
{
	int		w=bm->Width;
	int		h=bm->Height;
	int		h2=h/2;
	int		x,y,y2;
	TColor	c;

	for(x=0;	x<w;	x++)
	{
		for(y=0;	y<h2;	y++)
		{
			y2=h-y-1;
			c=bm->Canvas->Pixels[x][y];
			bm->Canvas->Pixels[x][y]=bm->Canvas->Pixels[x][y2];
			bm->Canvas->Pixels[x][y2]=c;
		}
	}
}

/*****	OtBbNX̐ݒ	*****/

void __fastcall	TSpeanaPanel::SetGraphics(AnsiString FileName)
{
	int		w,h,x,y;
	int		bw=0;
	if (BevelInner != bvNone)
	then    bw+=BevelWidth;
	if (BevelOuter != bvNone)
	then    bw+=BevelWidth;

	FGraphics=FileName;

	if (FGraphics.IsEmpty())
	then {
		if (FImage)
		then {
			delete	FImage;
			FImage=NULL;
		}
		if (FImageList)
		then {
			delete	FImageList;
			FImageList=NULL;
		}
		FType=mtLevel;
		return;
	}

	if (FType==mtGraphics)
	then {
		if (FImage)
		then {
			delete	FImage;
			FImage=NULL;
		}
		if (FImageList==NULL)
		then	FImageList=new TImageList(this);

		Graphics::TBitmap*	Bitmap=new Graphics::TBitmap();
		Bitmap->LoadFromFile(FGraphics);
		Graphics::TBitmap*	bm=new Graphics::TBitmap();
		Bitmap->PixelFormat=pf24bit;
		bm->PixelFormat=Bitmap->PixelFormat;
		bm->Canvas->CopyMode=cmSrcCopy;

		w=Bitmap->Width/11;
		h=Height-bw*2;
		if (h != Bitmap->Height)
		then {
			y=Bitmap->Height/h;
			if (y)
			then	h=Bitmap->Height/y;
			else	h=Bitmap->Height;
		}

		bm->Width=w;
		bm->Height=h;
		TRect	dest(0,0,w,h);
		TRect	src(0,0,w,h);

		FImageList->Width=w;
		FImageList->Height=h;
		FImageList->Clear();
		FImageList->Masked=false;

		for(y=0;	y<Bitmap->Height;	y+=h)
		{
			src.Top=y;
			src.Bottom=y+h;
			for(x=0;	x<Bitmap->Width;	x+=w)
			{
				src.Left=x;
				src.Right=x+w;
				bm->Canvas->CopyRect(dest,Bitmap->Canvas,src);
				switch(FDir)
				{
					case 2:
					case 6:
						MirrorH(bm);
						break;
					case 3:
					case 7:
						MirrorV(bm);
						break;
				}
				FImageList->Add(bm,NULL);
			}
		}
/*
		if (FDir & 1)
		then {
			w=(Width-bw*2)/10;
			h=Height-bw*2;
		}
		else {
			w=Width-bw*2;
			h=(Height-bw*2)/10;
		}
		bm->Width=w;
		bm->Height=h;
		TRect	dest(0,0,w,h);
		TRect	src(0,0,w,h);

		FImageList->Width=w;
		FImageList->Height=h;
		FImageList->Clear();
		FImageList->Masked=false;

		switch(FDir & 5)
		{
			case 0:
				dest.Right=w*11;
				src.Right=w*11;
				bm->Width=w*11;
				for(y=Bitmap->Height-h;	y>=0;	y-=h)
				{
					src.Top=y;
					src.Bottom=y+h;
					bm->Canvas->CopyRect(dest,Bitmap->Canvas,src);
					FImageList->Add(bm,NULL);
				}
				break;
			case 4:
				dest.Right=w*11;
				src.Right=w*11;
				for(y=0;	y<Bitmap->Height;	y+=h)
				{
					src.Top=y;
					src.Bottom=y+h;
					bm->Canvas->CopyRect(dest,Bitmap->Canvas,src);
					FImageList->Add(bm,NULL);
				}
				break;
			case 1:
				for(x=0;	x<Bitmap->Width;	x+=w)
				{
					src.Left=x;
					src.Right=x+w;
					for(y=0;	y<Bitmap->Height;	y+=h)
					{
						src.Top=y;
						src.Bottom=y+h;
						bm->Canvas->CopyRect(dest,Bitmap->Canvas,src);
						FImageList->Add(bm,NULL);
					}
				}
				break;
			case 5:
				for(x=Bitmap->Width-w;	x>=0;	x-=w)
				{
					src.Left=x;
					src.Right=x+w;
					for(y=0;	y<Bitmap->Height;	y+=h)
					{
						src.Top=y;
						src.Bottom=y+h;
						bm->Canvas->CopyRect(dest,Bitmap->Canvas,src);
						FImageList->Add(bm,NULL);
					}
				}
				break;
		}
*/
		delete	bm;
		delete	Bitmap;

		return;
	}
	if (FImageList)
	then {
		delete	FImageList;
		FImageList=NULL;
	}

	if (FImage==NULL)
	then {
		FImage=new TImage(this);
		FImage->Parent=this;
		FImage->OnClick=OnClick;
		FImage->OnDblClick=OnDblClick;
	}

	FImage->Left=bw;
	FImage->Top=bw;
	FImage->Width=Width-bw*2;
	FImage->Height=Height-bw*2;
	FImage->Picture->Bitmap->LoadFromFile(FGraphics);
	FImage->Visible=true;
}

/*****	End	*****/
