/*	Filename:SpeanaPanel.h						*/
/************************************************/
/*												*/
/*				vXyAipl+				*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	XyAiplW[		*/
/*                             					*/
/*		Copyright 2001,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef SpeanaPanelH
#define SpeanaPanelH

#include	"Meter.h"

/*----------------------------------------------*/
/*				 								*/
/*----------------------------------------------*/

/*----------------------------------------------*/
/*				TSpeanaPanelNX				*/
/*----------------------------------------------*/

enum	TPeakType	{ptDisable,ptNone,ptHold,ptDecay};

class	TSpeanaPanel:public TPanel
{
private:
	TMeter*			FLevelMeter[10];
	TMeter*			FPeakMeter[10];
	TMeterType		FType;						//[^^Cv
	TPeakType		FPeakType;
	int				FDir;
	AnsiString		FGraphics;
	TImage*			FImage;
	TImageList*		FImageList;

protected:
	TColor __fastcall	GetLevelColor(int Index);
	void __fastcall	SetLevelColor(int Index,TColor c);
	int __fastcall	GetLevel(int Index);
	void __fastcall	SetLevel(int Index,int level);
	void __fastcall	SetPeakType(TPeakType Type);
	void __fastcall	SetGraphics(AnsiString FileName);
	void __fastcall	MirrorH(Graphics::TBitmap *bm);
	void __fastcall	MirrorV(Graphics::TBitmap *bm);

public:
	__fastcall	TSpeanaPanel(Classes::TComponent* AOwner);
	__fastcall	~TSpeanaPanel(void);
	void __fastcall	Remake(void);
	void __fastcall	Clear(void);

	__property	int			Dir={read=FDir,write=FDir};
	__property	TMeterType	Type={read=FType,write=FType};
	__property	TPeakType	PeakType={read=FPeakType,write=SetPeakType};
	__property	TColor	LevelColor[int Index]={read=GetLevelColor,write=SetLevelColor};
	__property	int		Level[int Index]={read=GetLevel,write=SetLevel};
	__property	AnsiString	Graphics={read=FGraphics,write=SetGraphics};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/


#endif

/*****	End	*****/
