/*	Filename:main.h								*/
/************************************************/
/*												*/
/*				WXyAipl+   				*/
/*												*/
/*					Ver.6.31  					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 2001,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include "DSMP.h"
#include "SpeanaPanel.h"

#define	DEFWIDTH	246
#define	DEFHEIGHT	38

/*----------------------------------------------*/
/*				TWSpeanaNX					*/
/*----------------------------------------------*/

class	TWSpeana:public TComponent
{
private:
	TDSMP*			FDSMP;
	TForm*			FDSMPForm;
	TPanel*			FDSMPSpeana;
	TSpeanaPanel*	FSpeanaPanelL;
	TSpeanaPanel*	FSpeanaPanelR;

	char*			Sinbf;
	char*			Cosbf;
	double*			Sin;
	double*			Cos;
	bool			FFFT;						//FFTvZ
	char*			FFTRrbf;
	char*			FFTRibf;
	char*			FFTLrbf;
	char*			FFTLibf;
	double*			FFTLr;
	double*			FFTLi;
	double*			FFTRr;
	double*			FFTRi;
	int				FMaxL;						//̓xől
	int				FMaxR;
	int				FRecordingLevel;			//^x
	int				FSpeanaPattern;				//XyAip^[
	int				FAdjustSpeana;
	int				FDisplaySpeana;				//XyAi\
	TDSMPDisplayMode	FDisplayMode;

protected:
	void __fastcall	SpeanaPanelClick(TObject *Sender);
	void __fastcall	DSMPOnUser(TObject* Sender,DWORD Event,int Param);
	void __fastcall	DSMPOnChangeDisplayMode(TObject* Sender,TDSMPDisplayMode Mode);
	void __fastcall DSMPOnPlayStatus(TObject* Sender,int Param);
	void __fastcall DSMPOnVolume(TObject* Sender,int Left,int Right);
	void __fastcall DSMPOnSpeana(TObject* Sender,int *Level);
	void __fastcall DSMPOnSaveDSMPini(TObject* Sender);
	void __fastcall	DSMPOnAdjustLevel(TObject* Sender,int Type);
	void __fastcall Show(TSpeanaPanel *SpeanaPanel,double *FFTr,double *FFTi);
	void __fastcall FFT1(double *x,double *y,int Samples,bool Flag);
	double __fastcall   GetBandPower(int From,int To,double *FFTr,double *FFTi);
	void __fastcall MakeSinCos(int Samples);

public:
	__fastcall	TWSpeana(TComponent *Owner);
	__fastcall	~TWSpeana(void);
	void __fastcall Clear(void);
	void __fastcall	DSMPOnSampling(WAVEHDR *WaveHeader);

	__property	TDSMP	*DSMP={read=FDSMP};
	__property	int		MaxL={read=FMaxL,write=FMaxL};
	__property	int		MaxR={read=FMaxR,write=FMaxR};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	TDSMPInterface	*DSMPIntf;
extern	int				Version;
extern	TSpeanaPanel	*SpeanaPanel;

#endif

/*****	End	****/

