/*	Filename:Main.h								*/
/************************************************/
/*												*/
/*			LyrJvZ{iDSMPvOCj		*/
/*												*/
/*				CtH[W[		*/
/*												*/
/*					Ver.6.00  					*/
/*												*/
/*		Copyright 1997,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Buttons.hpp>
#include "DSMP.h"
#include "Region.h"

#define	crHandCursor	((TCursor)(16))

enum	TOrientation	{tHolizontal,tVertical};

/*----------------------------------------------*/
/*									  			*/
/*----------------------------------------------*/

int __fastcall  GetPanelBevelWidth(TPanel *Panel);

/*----------------------------------------------*/
/*				TMeterNX					*/
/*----------------------------------------------*/

class	TMeter
{
public:
	int		Level;
	int		Count;
	TColor	FBlue;
	TColor	FYellow;
	TColor	FRed;
	TColor	FColor;
	TLabel	*Label[10];

	TLabel* __fastcall	operator [](int Index)
	{
		return(Label[Index]);
	}
	void __fastcall	MakeLabel(TPanel* Panel,TOrientation dir,bool fPeak,int Bands,int Index,TColor Blue,TColor Yellow,TColor Red);
	void __fastcall	Display(int Level);
};

/*----------------------------------------------*/
/*				TFormLyrCapsuleNX  			*/
/*----------------------------------------------*/

enum	TFormPosition	{fpFree,fpUpper,fpUnder,fpLeft,fpRight,fpOffset};

class TFormLyrCapsule : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TPanel *PanelSpeana;
	TDSMP *DSMP;
	TPopupMenu *PopupMenu;
	TMenuItem *PopupTitle;
	TMenuItem *PopupLyrics;
	TMenuItem *N6;
	TMenuItem *PopupExit;
	TMenuItem *N7;
	TMenuItem *PopupPosition;
	TMenuItem *PopupPositionUpper;
	TMenuItem *PopupPositionUnder;
	TMenuItem *PopupPositionRight;
	TMenuItem *PopupPositionLeft;
	TMenuItem *PopupPositionFree;
	TMenuItem *PopupSpeana;
	TPanel *PanelDisplay;
	TLabel *LabelArtist;
	TLabel *LabelTitle;
	TLabel *LabelTrack;
	TLabel *LabelTime;
	TLabel *LabelPositionBack;
	TMenuItem *PopupPlayerVisible;
	TMenuItem *N2;
	TLabel *LabelPosition;
	TImageList *ImageList;
	TMenuItem *PopupHelp;
	TMenuItem *PopupPositionOffset;
	TSpeedButton *BtnPlayList;
	TSpeedButton *BtnLogo;
	TSpeedButton *BtnTool;
	TSpeedButton *SpeedButton1;
	TSpeedButton *BtnPlay;
	TSpeedButton *BtnDown;
	TPanel *PanelVolume;
	TImage *ImageTimer;
	TImage *ImageRepeat;
	TImage *ImageRandom;
	TImage *ImageForm;
	TImageList *ImageListPlay;
	TPanel *PanelLyrics;
	TLabel *LabelLyrics;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall DSMPLyrics(TObject *Sender,int Line);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall PopupPositionClick(TObject *Sender);
	void __fastcall DSMPMove(TObject *Sender, int Notify, int Param);
	void __fastcall PanelSpeanaClick(TObject *Sender);
	void __fastcall PopupLyricsClick(TObject *Sender);
	void __fastcall DSMPSpeana(TObject *Sender, int *Level);
	void __fastcall DSMPVolume(TObject *Sender, int Notify, int Param);
	void __fastcall PopupPlayerVisibleClick(TObject *Sender);
	void __fastcall DSMPStayOnTop(TObject *Sender, bool Flag);
	void __fastcall DSMPDisplayTitle(TObject *Sender, int Param);
	void __fastcall DSMPDisplayTrack(TObject *Sender, int Param);
	void __fastcall DSMPOpenTrack(TObject *Sender, int Param);
	void __fastcall LabelPositionMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall LabelPositionMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall LabelPositionMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall DSMPDisplayTimer(TObject *Sender, int Param);
	void __fastcall DSMPRepeat(TObject *Sender, bool Flag);
	void __fastcall DSMPRandom(TObject *Sender, bool Flag);
	void __fastcall ImageRepeatClick(TObject *Sender);
	void __fastcall ImageRandomClick(TObject *Sender);
	void __fastcall DSMPPlayStatus(TObject *Sender, int Param);
	void __fastcall BtnUpClick(TObject *Sender);
	void __fastcall BtnDownClick(TObject *Sender);
	void __fastcall BtnPlayClick(TObject *Sender);
	void __fastcall BtnPlayListClick(TObject *Sender);
	void __fastcall BtnToolClick(TObject *Sender);
	void __fastcall BtnLogoClick(TObject *Sender);
	void __fastcall PopupExitClick(TObject *Sender);
	void __fastcall PopupMenuPopup(TObject *Sender);
	void __fastcall PopupHelpClick(TObject *Sender);
	void __fastcall DSMPCounter(TObject *Sender, int Param);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall DSMPLoadLyrics(TObject *Sender);
	void __fastcall DSMPCloseTrack(TObject *Sender, int Param);

private:	// [U[錾
	bool			FClosed;
	int				FPosition;
	int				FDisplayMode;
	int				FLength;
	TColor			FDefBackColor;
	TColor			FLyrBackColor;
	TColor			FDefColor;
	TColor			FLyrColor;

	UINT			FMoveWindow;
	tagPOINT		FMoveWindowPos;
	int				FMoveWindowLeft;
	int				FMoveWindowTop;
	int				FPositionSet;
	int				FOffsetLeft;
	int				FOffsetTop;
	bool			FVolChange;
	dsvRegion*		RegionForm;

protected:
	void __fastcall CreateParams(Controls::TCreateParams &Params);
	void __fastcall	SetPosition(int left,int top);
	void __fastcall	SpeanaOff(void);
	void __fastcall	SpeanaOn(void);
	void __fastcall	SetEvent(int Mode);
	void __fastcall	SetDisplayMode(int Mode);
	void __fastcall	DisplayImage(TImage *Panel,TImageList *ImageList,int n);
	void __fastcall	DisplayRepeat(void);
	void __fastcall	DisplayRandom(void);
	void __fastcall	DisplayTimer(void);
	void __fastcall	DisplayVolume(void);
	void __fastcall LyrMenuClick(TObject *Sender);
	void __fastcall WMDropFiles(TWMDropFiles& Msg);

public:		// [U[錾
	TMeter			MeterSpeana[10];
	TMeter			MeterSpeanaPeak[10];
	TMeter			MeterVolume[2];


	__fastcall	TFormLyrCapsule(TComponent* Owner);
	__fastcall	~TFormLyrCapsule(void);
	void __fastcall	Created(void);
	void __fastcall	SaveIni(void);

	__property	bool	Closed={read=FClosed,write=FClosed};

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
END_MESSAGE_MAP(TScrollingWinControl)
};

/*----------------------------------------------*/
/*					Export						*/
/*----------------------------------------------*/
/*
extern "C" __declspec(dllexport)	void	pinRun(TDSMPInterface*);
extern "C" __declspec(dllexport)	void	pinAbort(void);
extern "C" __declspec(dllexport)	void	pinNotifyEvent(DWORD Event,int Param);
*/
/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern PACKAGE TFormLyrCapsule *FormLyrCapsule;

#endif

/*****	End	*****/
