/*	Filename:Region.CPP							*/
/************************************************/
/*												*/
/*			DELTA SOFT VCL Component			*/
/*												*/
/*				for VCL	Ver.6.00				*/
/*												*/
/*		[WRg[R|[lg	*/
/*												*/
/*		Copyright(C),1997,2002 by DELTA SOFT	*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*						`						*/
/*----------------------------------------------*/

#include <vcl.h>
#pragma hdrstop
#include "Region.h"

#pragma package(smart_init)

/*-----	My Programming Style	-----*/

#ifndef	then
#define	then
#endif
#ifndef	OR
#define	OR	||
#endif
#ifndef	AND
#define	AND	&&
#endif

/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	z֐Ȃ؂	*****/

// ValidCtrCheck ́A`ꂽR|[lgz֐܂
// ۃNXł͂ȂƂmF邽߂ɒ`Ă܂B
//

static inline void ValidCtrCheck(dsvRegion *)
{
	new dsvRegion((TImage*)NULL);
}

/*****	pbgւ̓o^	*****/

namespace Region
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(dsvRegion)};
		RegisterComponents("DELTA", classes, 0);
	}
}

/*----------------------------------------------*/
/*			dsvRegionNX						*/
/*----------------------------------------------*/

/*****	RXgN^	*****/
/*
__fastcall dsvRegion::dsvRegion(TComponent* Owner)
	: TComponent(Owner)
{
}
*/
/*****	RXgN^	*****/

__fastcall	dsvRegion::dsvRegion(TImage* Image)
	:TComponent(Image->Owner)
{
	FImage=Image;
}

/*****	fXgN^	*****/

__fastcall	dsvRegion::~dsvRegion()
{
	if (FRgn)
	then	DeleteObject(FRgn);
}

/*****	ߐF̐ݒ	*****/

void __fastcall	dsvRegion::SetTransparentColor(TColor color)
{
	FTransparentColor=color;
	FImage->Picture->Bitmap->TransparentColor=color;
}

/*****	[WNA	*****/

void __fastcall	dsvRegion::Clear(void)
{
	if (FRgn)
	then	DeleteObject(FRgn);

	FRgn=::CreateRectRgn(0,0,0,0);			//ʐ0̃[W𐶐
	if (FRgn==0)
	then	throw	Exception("CreateRectRgnɎs܂");
}

/*****	[W̒ǉ	*****/

void __fastcall	dsvRegion::Add(int x,int y,int Width,int Height)
{
	HRGN	TmpRectRgn;

	if (FRgn==0)
	then {
		try {
			Clear();
		}
		catch(...)
		{
			throw;
		}
	}

	x+=FImage->Left;
	y+=FImage->Top;
	TmpRectRgn=::CreateRectRgn(x,y,x+Width,y+Height);
	if (TmpRectRgn==0)
	then	throw Exception("CreateRectRgnɎs܂");
	try {
		if (::CombineRgn(FRgn,FRgn,TmpRectRgn,RGN_OR)==ERROR)
		then	throw Exception("CombineRgnɎs܂");
	}
	__finally {
		DeleteObject(TmpRectRgn);
	}
}

/*****	C[W烊[W̍쐬	*****/

void __fastcall	dsvRegion::Create(void)
{
	int		x,y;
	int		left;
	TColor	c;

	try {
		Clear();
		for(y=0;	y<FImage->Height;	y++)
		{
			left=-1;
			for(x=0;	x<FImage->Width;	x++)	//XɃXLAߐFȊÖ̗[WɉĂ
			{
				c=FImage->Canvas->Pixels[x][y];
				if ((left<0) AND (c != FTransparentColor))
				then	left=x;
				else if ((left>=0) AND (c==FTransparentColor))
				then {
					Add(left,y,x-left,1);
					left=-1;
				}
			}
			if (left>=0)
			then	Add(left,y,x-left,1);
		}
	}
	catch(...)
	{
		if (FRgn)
		then	DeleteObject(FRgn);  	// oオr[ȃ[W͔j
		FRgn=0;
		throw;				            // ʂɗOグ
	}
}

/*****	[WWindowɐݒ	******/

void __fastcall	dsvRegion::Set(void)
{
	HRGN	WindowRgn;

	if (FRgn)
	then {
		if (FImage->Parent==NULL)
		then	throw	Exception("Parentݒ肳Ă܂");
		if (FImage->Parent->HandleAllocated()==false)
		then	return;

		WindowRgn=::CreateRectRgn(0,0,0,0);				//OSɓn[W쐬
		if (WindowRgn==0)
		then	throw	Exception("CreateRectRgnɎs܂");
		try {
			if (::CombineRgn(WindowRgn,WindowRgn,FRgn,RGN_OR)==ERROR)
			then	throw	Exception("CombineRgnɎs܂");
			if (::SetWindowRgn(FImage->Parent->Handle,WindowRgn,TRUE)==False)
			then	throw	Exception("SetWindowRgnɎs܂");
		}
		catch(...)
		{
			if (WindowRgn)
			then	DeleteObject(WindowRgn);
			throw;
		}
	}
}

/*****	[W̍폜	*****/

void __fastcall	dsvRegion::Delete(void)
{
	if (::SetWindowRgn(FImage->Parent->Handle,NULL,TRUE))
	then {
		if (FRgn)
		then {
			DeleteObject(FRgn);
			FRgn=NULL;
		}
	}
	else	throw	Exception("SetWindowRgnɎs܂");
}

/*****	End	*****/

