/*	Filename:main.cpp							*/
/************************************************/
/*												*/
/*					DSMPiCt{				*/
/*												*/
/*					Ver.6.00   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 1999,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <IniFiles.hpp>
#include <shellapi.h>
#pragma hdrstop

#include "main.h"

#pragma package(smart_init)

#pragma resource "*.dfm"

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TDSMPInterface	*DSMPIntf;
TDSMPKnife		*DSMPKnife;
int				Version=6003;
AnsiString		DllPath;
HANDLE			hMutex;

/*----------------------------------------------*/
/*				O[o֐					*/
/*----------------------------------------------*/

/*****	DLLsJn	*****/

void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if ((DSMPIntf->CheckVersion(DSMP_DLLVERSION)==false)
		OR (DSMPIntf->GetVersion()<DSMP_VERSION))
	then {
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg("DSMP Knife+\n\ño[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);
		DSMPIntf->Abort();
		return;
	}

	hMutex=::CreateMutex(NULL,FALSE,"DSMPKnife");
	if ((hMutex==0) OR (::GetLastError()==ERROR_ALREADY_EXISTS))
	then {
		DSMPIntf->Abort();
		return;
	}

	DllPath=DSMPIntf->GetDllPath();

	DSMPKnife=new TDSMPKnife(DSMPIntf->GetPlayerForm());
}

/*****	DLLA{[g	*****/

void	pinAbort(void)
{
	if (DSMPKnife)
	then {
		delete	DSMPKnife;
		DSMPKnife=NULL;
	}
	if (hMutex)
	then {
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		hMutex=0;
	}
}

/*****	DLLCxgʒm	*****/
/*
void	pinNotifyEvent(DWORD Event,int Param)
{
}
*/
/*****	OpenPlayFiletB^[C^[tF[X	*****/

char*	pinOpenPlayFile(char *FileName)
{
	if (DSMPKnife)
	then	FileName=DSMPKnife->OpenPlayFile(FileName);

	return(FileName);
}

/*----------------------------------------------*/
/*				TDSMPKnifeNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TDSMPKnife::TDSMPKnife(TComponent *Owner)
:TComponent(Owner)
{
	AnsiString	S,mcircp;

	FDSMP=new TDSMP(Owner);
	FDSMP->Bind();
	FDSMP->OnUser=DSMPOnUser;
	FDSMP->OnDisplayMenu=DSMPOnDisplayMenu;

	FSMFKnife=new TSMFKnife(DSMP->DSMPHandle);
	FRcpCv=new TRCPCV();

	FSMFKnife->OnCallBack=OnCallBack;
	FRcpCv->OnCallBack=OnCallBack;

	FFileCount=0;
	InFileList=new TStringList();
	OutFileList=new TStringList();

	TIniFile	*File=new TIniFile("WIN.INI");

	mcircp=File->ReadString("mci extensions","rcp","");
	if (mcircp.IsEmpty())
	then {
		mcircp="Sequencer";
		File->WriteString("mci extensions","rcp",mcircp);
	}
	S=File->ReadString("mci extensions","r36","");
	if (S.IsEmpty())
	then	File->WriteString("mci extensions","r36",mcircp);
	S=File->ReadString("mci extensions","g36","Sequencer");
	if (S.IsEmpty())
	then	File->WriteString("mci extensions","g36",mcircp);

	delete	File;

	File=new TIniFile(ChangeFileExt(DllPath,".ini"));

	FCacheFiles=File->ReadInteger("DSMPKnife","Cache",2);

	FRcpCv->Enabled=File->ReadBool("DSMPKnife","RCPCV",false);

	SMFKnife->Enabled=File->ReadBool("DSMPKnife","SMFKnife",false);
	SMFKnifeConfig=File->ReadString("DSMPKnife","SMFKConfig","");
	SMFKnife->Option->nJv=File->ReadInteger("DSMPKnife","SMFKCh10",-1);
	SMFKnife->Option->nBnk=File->ReadInteger("DSMPKnife","SMFKBank",-1);
	SMFKnife->Option->nMac=File->ReadInteger("DSMPKnife","SMFKMac",-1);
	SMFKnife->Option->nP=File->ReadInteger("DSMPKnife","SMFKCC64",-1);

	delete	File;

	if (FCacheFiles<1)
	then	FCacheFiles=1;
	if ((FSMFKnife->Enabled) AND (FRcpCv->Enabled) AND (FCacheFiles<2))
	then	FCacheFiles=2;

	TDSMPMenu	*Menu;

	FPlayerMenuDSMPKnife=DSMP->PlayerMenu->Add("DSMPiCt{");
	FPlayerMenuDSMPKnife->OnClick=DSMPKnifeMenuClick;

	FPlayListMenuLine=DSMP->PlayListPopupMenu->Add("-");
	FPlayListMenuDSMPKnife=DSMP->PlayListPopupMenu->Add("DSMPiCt{");
		FMenuSMFKnife=FPlayListMenuDSMPKnife->Add("SMFiCt");
			Menu=FMenuSMFKnife->Add("ftHg");
			Menu->OnClick=SMFKnifeDefaultOnClick;
			FMenuSMFKnifeConfig=FMenuSMFKnife->Add("Config File");
			FMenuSMFKnifeConfig->OnClick=SMFKnifeConfigOnClick;
			Menu=FMenuSMFKnife->Add("̑...");
			Menu->OnClick=SMFKnifeEtcOnClick;
		Menu=FPlayListMenuDSMPKnife->Add("vpeB...");
		Menu->OnClick=DSMPKnifeMenuClick;
		Menu=FPlayListMenuDSMPKnife->Add("wv");
		Menu->OnClick=DSMPKnifeHelpClick;
		FPlayListMenuDSMPKnife->Add("-");
		Menu=FPlayListMenuDSMPKnife->Add("I");
		Menu->OnClick=DSMPKnifeAbortClick;

	FWorkDir=ExtractFileDir(DllPath);

	S=ChangeFileExt(DSMP->DSMPPath,".ini");

	File=new TIniFile(S);

	FWorkDir=File->ReadString("DSMP","WorkDir",FWorkDir);

	delete	File;
}

/*****	fXgN^	*****/

__fastcall	TDSMPKnife::~TDSMPKnife(void)
{
	SaveIni();

	if (FormMain)
	then {
		delete	FormMain;
		FormMain=NULL;
	}
														//ej[̍폜ł
	FDSMP->PlayerMenu->Remove(FPlayerMenuDSMPKnife);
	FDSMP->PlayListPopupMenu->Remove(FPlayListMenuDSMPKnife);
	FDSMP->PlayListPopupMenu->Remove(FPlayListMenuLine);

	delete	FDSMP;
	FDSMP=NULL;
	delete	FSMFKnife;
	delete	FRcpCv;

	DeleteCacheFiles();

	delete	InFileList;
	delete	OutFileList;
}

/*****	DSMPKnife.inĩZ[u	*****/

void __fastcall	TDSMPKnife::SaveIni(void)
{
	TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

	File->WriteInteger("DSMPKnife","Version",Version);
	File->WriteInteger("DSMPKnife","Cache",FCacheFiles);
	File->WriteBool("DSMPKnife","RCPCV",RcpCv->Enabled);
	File->WriteBool("DSMPKnife","SMFKnife",SMFKnife->Enabled);
	File->WriteString("DSMPKnife","SMFKConfig",SMFKnifeConfig);
	File->WriteInteger("DSMPKnife","SMFKCh10",SMFKnife->Option->nJv);
	File->WriteInteger("DSMPKnife","SMFKBank",SMFKnife->Option->nBnk);
	File->WriteInteger("DSMPKnife","SMFKMac",SMFKnife->Option->nMac);
	File->WriteInteger("DSMPKnife","SMFKCC64",SMFKnife->Option->nP);

	delete	File;
}

/*****	SMFKnife Configt@C̐ݒ	*****/

void __fastcall	TDSMPKnife::SetSMFKnifeConfig(AnsiString S)
{
	FSMFKnifeConfig=S;
	FSMFKErrMsg=false;
	FCacheCansel=true;
}

/*****	SMFKnife Configt@C̎擾	*****/

AnsiString __fastcall	TDSMPKnife::GetSMFKnifeConfig(AnsiString FileName)
{
	TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

	AnsiString	S=File->ReadString("SMFKnife",FileName,"");
	if (S.IsEmpty())
	then	S=SMFKnifeConfig;

	delete	File;

	return(S);
}

/*****	SMFKnife Configt@C̎擾	*****/

AnsiString __fastcall	TDSMPKnife::GetSMFKnifeConfig(void)
{
	int		Track=DSMP->PlayList->Selected;

	if (Track<1)
	then	return(SMFKnifeConfig);

	AnsiString	FileName=DSMP->TrackInfo[Track].FileName;

	if (FileName.IsEmpty())
	then	return(SMFKnifeConfig);

	return(GetSMFKnifeConfig(FileName));
}

/******	DSMPKnifej[NbN	*****/

void __fastcall	TDSMPKnife::DSMPKnifeMenuClick(TObject *Sender)
{
	if (FormMain==NULL)
	then	FormMain=new TFormMain(DSMPIntf->GetPlayerForm());

	FormMain->Show();
}

/******	DSMPKnifewvj[NbN	*****/

void __fastcall	TDSMPKnife::DSMPKnifeHelpClick(TObject *Sender)
{
	AnsiString	S=ChangeFileExt(DllPath,".chm");

	ShellExecute(DSMP->DSMPHandle,NULL,S.c_str(),NULL,NULL,SW_SHOWNORMAL);
}

/******	DSMPKnifeIj[NbN	*****/

void __fastcall	TDSMPKnife::DSMPKnifeAbortClick(TObject *Sender)
{
	FDSMP->Abort();
}

/*****	SMFiCtftHgj[NbN	*****/

void __fastcall	TDSMPKnife::SMFKnifeDefaultOnClick(TObject *Sender)
{
	AnsiString	FileName=DSMP->TrackInfo[DSMP->PlayList->Selected].FileName;

	if (FileName.IsEmpty())
	then	return;

	TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

	File->DeleteKey("SMFKnife",FileName);

	delete	File;

	FCacheCansel=true;
}

/*****	SMFiCtRtBOt@Cj[NbN	*****/

void __fastcall	TDSMPKnife::SMFKnifeConfigOnClick(TObject *Sender)
{
	AnsiString	FileName=DSMP->TrackInfo[DSMP->PlayList->Selected].FileName;

	if (FileName.IsEmpty())
	then	return;

	TDSMPMenu	*Menu=(TDSMPMenu*)Sender;
	TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

	File->WriteString("SMFKnife",FileName,Menu->Caption);

	delete	File;

	FCacheCansel=true;
}

/*****	SMFiCt̑j[NbN	*****/

void __fastcall	TDSMPKnife::SMFKnifeEtcOnClick(TObject *Sender)
{
	AnsiString	FileName=DSMP->TrackInfo[DSMP->PlayList->Selected].FileName;

	if (FileName.IsEmpty())
	then	return;

	AnsiString	S=GetSMFKnifeConfig(FileName);

	TOpenDialog	*OpenDialog=new TOpenDialog(this);

	OpenDialog->Title="SMFiCt RtBOt@C";
	OpenDialog->Options=TOpenOptions()<<ofHideReadOnly<<ofPathMustExist<<ofFileMustExist;
	OpenDialog->Filter="RtBOt@C (*.cfg)|*.cfg|ׂẴt@C (*.*)|*.*";
	OpenDialog->FilterIndex=1;
	OpenDialog->FileName=S;
	if (OpenDialog->Execute())
	then {
		S=OpenDialog->FileName;

		TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

		File->WriteString("SMFKnife",FileName,S);

		delete	File;
		FCacheCansel=true;
	}

	delete	OpenDialog;
}

/*****	DSMP_STATUS_DISPLAYMENU	*****/

void __fastcall	TDSMPKnife::DSMPOnDisplayMenu(TObject *Sender)
{
	TDSMPMenu	*Menu=(TDSMPMenu*)Sender;

	if (Menu==DSMP->PlayListPopupMenu)
	then {
		AnsiString	FileName=DSMP->TrackInfo[DSMP->PlayList->Selected].FileName;

		AnsiString	S;

		if (!FileName.IsEmpty())
		then {
			TIniFile	*File=new TIniFile(ChangeFileExt(DllPath,".ini"));

			S=File->ReadString("SMFKnife",FileName,"");

			delete	File;
		}
		if (S.IsEmpty())
		then	S=SMFKnifeConfig;

		FMenuSMFKnifeConfig->Caption=S;

		S=AnsiLowerCase(ExtractFileExt(FileName));

		if ((S==".rcp") OR (S==".r36") OR (S==".g36") OR (S==".mid") OR (S==".rmi"))
		then	FMenuSMFKnife->Enabled=true;
		else	FMenuSMFKnife->Enabled=false;
	}
}

/******	DSMP_NOTIFY_USER	*****/

void __fastcall	TDSMPKnife::DSMPOnUser(TObject* Sender,DWORD Event,int Param)
{
	if (Event==DSMP_NOTIFY_CLOSE)
	then {
		if (FormMain)
		then {
			delete	FormMain;
			FormMain=NULL;
		}
	}
}

/*****	ϊꎞt@C̍폜	*****/

void __fastcall	TDSMPKnife::DeleteCacheFiles(void)
{
	int		i;

	for(i=0;	i<OutFileList->Count;	i++)
	{
		if (FileExists(OutFileList->Strings[i]))
		then	DeleteFile(OutFileList->Strings[i]);
	}
	OutFileList->Clear();
	InFileList->Clear();
}

/*****	t@C̎擾	*****/

AnsiString	__fastcall	TDSMPKnife::GetOutFileName(AnsiString FileName,bool &Exists)
{
	Exists=false;

	if (FCacheCansel)
	then {
		DeleteCacheFiles();
		FCacheCansel=false;
	}

	int		n=InFileList->IndexOf(FileName);

	if (n>=0)
	then {
		if (FileExists(OutFileList->Strings[n]))
		then {
			if (n)
			then {									//Xg̐擪ɂ
				InFileList->Move(n,0);
				OutFileList->Move(n,0);
			}
			Exists=true;
			return(OutFileList->Strings[0]);
		}
		InFileList->Delete(n);
		OutFileList->Delete(n);
	}

	AnsiString	S;
	AnsiString	fn;

	while(InFileList->Count>=FCacheFiles)					//ő쐬z
	{														//Xg̍Ō폜
		S=OutFileList->Strings[OutFileList->Count-1];
		if (FileExists(S))
		then	DeleteFile(S);

		InFileList->Delete(InFileList->Count-1);
		OutFileList->Delete(OutFileList->Count-1);
	}
	do {
		fn="DSMPK";
		fn+=FFileCount;
		fn+=".mid";
		S=FWorkDir+"\\";
		S+=fn;
		FFileCount++;
	} while(OutFileList->IndexOf(S)>=0);
	InFileList->Insert(0,FileName);
	OutFileList->Insert(0,S);

	return(OutFileList->Strings[0]);
}

/*****	OpenPlayFiletB^[C^[tF[X	*****/

char* __fastcall	TDSMPKnife::OpenPlayFile(char *FileName)
{
	InFileName=FileName;
	bool		Exists;
	int			Type;

	if (((RcpCv->Enabled==false) AND (SMFKnife->Enabled==false))
		OR (InFileName.IsEmpty()))
	then	return(FileName);

	AnsiString	Ext=AnsiLowerCase(ExtractFileExt(InFileName));

	if ((Ext==".rcp") OR (Ext==".r36") OR (Ext==".g36"))
	then	Type=1;
	else if ((Ext==".mid") OR (Ext==".rmi"))
	then	Type=2;
	else	return(FileName);

	if (((Type==1) AND (RcpCv->Enabled))
		OR ((Type==2) AND (SMFKnife->Enabled)))
	then	OutFileName=GetOutFileName(InFileName,Exists);
	else	return(FileName);

	if ((RcpCv->Enabled) AND (Type==1))
	then {
		if (Exists==false)
		then	RcpCv->Convert(InFileName,OutFileName);
		if (SMFKnife->Enabled)
		then {
			InFileName=OutFileName;
			OutFileName=GetOutFileName(InFileName,Exists);
			Type=3;
		}
	}
	if ((Exists==false) AND (SMFKnife->Enabled) AND (Type>=2))
	then {

		SMFKnife->Config=GetSMFKnifeConfig(FileName);

		if (SMFKnife->Config.IsEmpty())
		then {
			if (FSMFKErrMsg==false)
			then {
				MessageBeep(MB_ICONEXCLAMATION);
				MessageDlg("SMFiCt RtBOt@Cݒ肳Ă܂",mtError,TMsgDlgButtons()<<mbOK,0);
				FSMFKErrMsg=true;
LSMFKErr:
				if (Type==3)
				then	return(InFileName.c_str());
				else	return(FileName);
			}
		}
		SMFKnife->Convert(InFileName,OutFileName);

		if (SMFKnife->Error)
		then {
			MessageBeep(MB_ICONEXCLAMATION);
			goto LSMFKErr;
		}
	}

	return(OutFileName.c_str());
}

/*****	SMFKnife/RCPCVR[obN	******/

void __fastcall TDSMPKnife::OnCallBack(TObject* Sender,int Percent,bool &Abort)
{
	DSMP->Counter=Percent;
}

/*----------------------------------------------*/
/*				TFormMainNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall TFormMain::TFormMain(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString	S="DSMPiCt{  Ver.";
	S+=FormatFloat("##.000",(double)Version/1000.0);
	Caption=S;

	CheckBoxSMFKnife->Checked=DSMPKnife->SMFKnife->Enabled;
	CheckBoxRCPCV->Checked=DSMPKnife->RcpCv->Enabled;

	EditCache->Text=DSMPKnife->CacheFiles;

	EditSMFKConfig->Text=DSMPKnife->SMFKnifeConfig;
	CheckBoxSMFKCh10->Checked=! DSMPKnife->SMFKnife->Option->nJv;
	CheckBoxSMFKBank->Checked=! DSMPKnife->SMFKnife->Option->nBnk;
	CheckBoxSMFKMac->Checked=DSMPKnife->SMFKnife->Option->nMac;
	CheckBoxSMFKCC64->Checked=! DSMPKnife->SMFKnife->Option->nP;

}

/*****	tH[	*****/

void __fastcall TFormMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	DSMPKnife->DSMP->NotifyEvent(DSMPKnife->DSMP->Handle,DSMP_NOTIFY_USER | DSMP_NOTIFY_CLOSE,0);		//[_tH[ɂȂ
}

/*****	OK	*****/

void __fastcall TFormMain::BtnOKClick(TObject *Sender)
{
	DSMPKnife->SMFKnife->Enabled=CheckBoxSMFKnife->Checked;
	DSMPKnife->RcpCv->Enabled=CheckBoxRCPCV->Checked;

	int	n=EditCache->Text.ToIntDef(-1);
	if (n>=1)
	then	DSMPKnife->CacheFiles=n;

	DSMPKnife->SMFKnifeConfig=EditSMFKConfig->Text;
	DSMPKnife->SMFKnife->Option->nJv=CheckBoxSMFKCh10->Checked ? 0:-1;
	DSMPKnife->SMFKnife->Option->nBnk=CheckBoxSMFKBank->Checked ? 0:-1;
	DSMPKnife->SMFKnife->Option->nMac=CheckBoxSMFKMac->Checked ? -1:0;
	DSMPKnife->SMFKnife->Option->nP=CheckBoxSMFKCC64->Checked ? 0:-1;

	if ((DSMPKnife->SMFKnife->Enabled) AND (DSMPKnife->RcpCv->Enabled)
		AND (DSMPKnife->CacheFiles<2))
	then	DSMPKnife->CacheFiles=2;

	if (DSMPKnife->SMFKnife->Enabled != CheckBoxSMFKnife->Checked)
	then {
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg("SMFK32.DLL܂",mtError,TMsgDlgButtons()<<mbOK,0);
	}
	if (DSMPKnife->RcpCv->Enabled != CheckBoxRCPCV->Checked)
	then {
		MessageBeep(MB_ICONEXCLAMATION);
		MessageDlg("RCPCV.DLL܂",mtError,TMsgDlgButtons()<<mbOK,0);
	}

	DSMPKnife->SaveIni();

	Close();
}

/*****	LZ	*****/

void __fastcall TFormMain::BtnCancelClick(TObject *Sender)
{
	Close();
}


/*****	wv	*****/

void __fastcall TFormMain::BtnHelpClick(TObject *Sender)
{
	AnsiString	S=ChangeFileExt(DllPath,".chm");

	ShellExecute(Handle,NULL,S.c_str(),NULL,NULL,SW_SHOWNORMAL);
}

/*****	RtBOt@CQ	*****/

void __fastcall TFormMain::ButtonSMFKConfigClick(TObject *Sender)
{
	OpenDialog->FileName=EditSMFKConfig->Text;
	if (OpenDialog->Execute())
	then {
		EditSMFKConfig->Text=OpenDialog->FileName;
	}
}

/*****	End	*****/

