/*	Filename:main.cpp							*/
/************************************************/
/*												*/
/*				DSMP Extender+					*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*			 	CW[				*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <IniFiles.hpp>
#include <Registry.hpp>
#include <shellapi.h>
#pragma hdrstop
#include "main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

SHSTDAPI_(void) SHChangeNotify(LONG wEventId, UINT uFlags, LPCVOID dwItem1, LPCVOID dwItem2);
#define SHCNE_ASSOCCHANGED        0x08000000L

#define	WS_TITLEBAR	WS_CAPTION

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TDSMPInterface	*DSMPIntf;
int				Version=6310;
HANDLE			hMutex;
TDSMPExtender	*DSMPExtender;
HWND			DSMPWnd;
TForm			*DSMPForm;

/*-----	ftHgV[gJbg	-----*/

TShortCuts	ShortCuts[]=
{
{"~",DSMP_ID_STOP,VK_END},
{"Đ",DSMP_ID_PLAY,VK_HOME},
{"ꎞ~",DSMP_ID_PAUSE,VK_PAUSE},
{"Đ/~",DSMP_ID_PLAYSTOP,VK_SPACE},
{"",DSMP_ID_FF,VK_INSERT},
{"߂",DSMP_ID_REWIND,VK_DELETE},
{"̃gbN",DSMP_ID_NEXT,VK_NEXT},
{"ÕgbN",DSMP_ID_BACK,VK_PRIOR},
{"gbN̐擪",DSMP_ID_REWINDTOP,VK_BACK},
{"^",DSMP_ID_RECORD,'R' | scCtrl | scShift},
{"o",DSMP_ID_EJECT,'E' | scCtrl},
{"wv",DSMP_ID_HELP,VK_F1},
{"vCXg",DSMP_ID_PLAYLIST,VK_F2},
{"vpeB",DSMP_ID_LOGO,VK_F3},
{"j[",DSMP_ID_MENU,VK_F4},
{"c[",DSMP_ID_TOOL,VK_F5},
{"̎t@CҏW",DSMP_ID_EDITLYRICS,VK_F5 | scCtrl},
{"()",DSMP_ID_VOLUP,VK_ADD},
{"()",DSMP_ID_VOLDOWN,VK_SUBTRACT},
{"~[g",DSMP_ID_MUTE,VK_F6},
{"ĐRg[",DSMP_MENU_PLAYER_VOLUME+1,VK_F6 | scCtrl},
{"^Rg[",DSMP_MENU_PLAYER_VOLUME+2,VK_F6 | scShift},
{"s[g",DSMP_ID_REPEAT,VK_F7},
{"_",DSMP_ID_RANDOM,VK_F8},
{"̎/XyAi",DSMP_ID_LYRICS,VK_F9},
{"c莞/oߎ",DSMP_ID_TIMECOUNTER,'T' | scCtrl},
{"ŏ",DSMP_ID_MINIMIZE,VK_END | scCtrl},
{"tXN[",DSMP_ID_FULLSCREEN,VK_F12},
{"I",DSMP_ID_CLOSE,VK_F4 | scAlt},
{"vC[",DSMP_ID_FORM,VK_F11},
{"GNXe_[",DSMP_ID_EXTENDER,VK_F10},
{"",0,0}
};

/*----------------------------------------------*/
/*				GNX|[g					*/
/*----------------------------------------------*/

/*****	vOC̎s	*****/

void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if ((DSMPIntf->CheckVersion(DSMP_DLLVERSION)==false)
		OR (DSMPIntf->GetVersion()<DSMP_VERSION))
	then {
		MessageDlg("DSMP Extender+\n\ño[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);
		DSMPIntf->Abort();
		return;
	}

	hMutex=::CreateMutex(NULL,FALSE,"DSMPExtender");
	if ((hMutex==0) OR (::GetLastError()==ERROR_ALREADY_EXISTS))
	then {
		DSMPIntf->Abort();		  					//2dNȂI
		return;
	}

	DSMPForm=DSMPIntf->GetPlayerForm();
	DSMPWnd=DSMPForm->Handle;

	DSMPExtender=new TDSMPExtender(DSMPForm);
}

/*****	vOC̏I	*****/

void	pinAbort(void)
{
	if (DSMPExtender)
	then {
		delete	DSMPExtender;
		DSMPExtender=NULL;
	}

	if (hMutex)
	then {
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		hMutex=0;
	}
}

/*****	L[̓tB^[	*****/

void	pinKeyDown(WORD &Key,char &Shift)
{
	if (DSMPExtender)
	then	DSMPExtender->KeyDown(Key,*((TShiftState*)&Shift));	//cast͂قƂ͔
}

/*****	t@ChbvtB^[	*****/

char*	pinDropFile(char *Path)
{
	if ((DSMPExtender) AND (DSMPExtender->DDGraphics))
	then {
		AnsiString	Ext=AnsiLowerCase(ExtractFileExt(Path));
		if ((Ext==".jpg") OR (Ext==".jpeg")
			OR (Ext==".gif") OR (Ext==".bmp") OR (Ext==".png"))
		then {
			::ShellExecute(NULL,"open",DSMPExtender->IEPath.c_str(),Path,NULL,SW_SHOWNORMAL);
			return(NULL);
		}
	}
	return(Path);
}

/*----------------------------------------------*/
/*				TShortCutsNX				*/
/*----------------------------------------------*/

/*****	V[gJbgL[eLXg̎擾	*****/

AnsiString __fastcall	TShortCuts::GetShortCutText(void)
{
	AnsiString	S=::ShortCutToText(Key);
	if ((S.IsEmpty()) AND (Key))
	then {
		char		bf[32];

		if (Key & scShift)
		then {
			::GetKeyNameText(::MapVirtualKey(VK_SHIFT,0)<<16,bf,32);
			S=bf;
			S+="+";
		}
		if (Key & scCtrl)
		then {
			::GetKeyNameText(::MapVirtualKey(VK_CONTROL,0)<<16,bf,32);
			S=bf;
			S+="+";
		}
		if (Key & scAlt)
		then {
			::GetKeyNameText(::MapVirtualKey(VK_MENU,0)<<16,bf,32);
			S=bf;
			S="+";
		}
		switch(Key & 0xFF)
		{
			case VK_PAUSE:
				S+="Pause";
				break;
			case VK_ADD:
				S+="+";
				break;
			case VK_SUBTRACT:
				S+="-";
				break;
			case VK_DIVIDE:
				S+="/";
				break;
			case VK_MULTIPLY:
				S+="*";
				break;
			case VK_DECIMAL:
				S+=".";
				break;
		}
	}
	return(S);
}

/*****	V[gJbgL[eLXg̐ݒ	*****/

void __fastcall	TShortCuts::SetShortCutText(AnsiString Text)
{
	Key=0;

	if (Text.IsEmpty())
	then	return;

	AnsiString	S;
	char	bf[32];

	::GetKeyNameText(::MapVirtualKey(VK_SHIFT,0)<<16,bf,32);
	S=bf;
	S+="+";
	if (Text.AnsiPos(S)>=1)
	then {
		Text=StringReplace(Text,S,"",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
		Key |=scShift;
	}
	::GetKeyNameText(::MapVirtualKey(VK_CONTROL,0)<<16,bf,32);
	S=bf;
	S+="+";
	if (Text.AnsiPos(S)>=1)
	then {
		Text=StringReplace(Text,S,"",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
		Key |=scCtrl;
	}
	::GetKeyNameText(::MapVirtualKey(VK_MENU,0)<<16,bf,32);
	S=bf;
	S+="+";
	if (Text.AnsiPos(S)>=1)
	then {
		Text=StringReplace(Text,S,"",TReplaceFlags()<<rfReplaceAll<<rfIgnoreCase);
		Key |=scAlt;
	}

	if (Text.AnsiCompareIC("pause")==0)
	then	Key |=VK_PAUSE;
	else if (Text=="+")
	then	Key |=VK_ADD;
	else if (Text=="-")
	then	Key |=VK_SUBTRACT;
	else if (Text=="/")
	then	Key |=VK_DIVIDE;
	else if (Text=="*")
	then	Key |=VK_MULTIPLY;
	else if (Text==".")
	then	Key |=VK_DECIMAL;
	else	Key |=TextToShortCut(Text);
}

/*----------------------------------------------*/
/*				TDSMPExtenderNX				*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall	TDSMPExtender::TDSMPExtender(TComponent *Owner)
:TComponent(Owner)
{
	TDSMPMenu	*Menu;

	FDSMP=new TDSMP(Owner);
	FDSMP->Bind();
	FDSMP->OnIntTimer=DSMPOnIntTimer;
	FDSMP->OnUser=DSMPOnUser;
	FDSMP->OnDisplayMenu=OnDisplayMenu;
	FDSMP->OnOpenTrack=OnOpenTrack;
	FDSMP->OnCloseTrack=OnCloseTrack;
	FDSMP->OnPlayStatus=OnPlayStatus;
	FDSMP->OnMove=OnMove;
	FDSMP->OnMoved=OnMoved;
	FDSMP->OnDesign=OnDesign;
	FDSMP->OnOpen=OnDesign;							//DSMP̎sJn

	MenuExtender=FDSMP->PlayerMenu->Add("GNXe_[");
	MenuJacket=MenuExtender->Add("WPbg\");
	MenuJacket->OnClick=MenuJacketClick;
	Menu=MenuExtender->Add("vC[摜Rs[");
	Menu->OnClick=MenuCopyFormClick;
	Menu=MenuExtender->Add("ACRĕ`");
	Menu->OnClick=MenuRedrawIconClick;
	Menu=MenuExtender->Add("vpeB...");
	Menu->OnClick=MenuPropertyClick;
	Menu=MenuExtender->Add("wv");
	Menu->OnClick=ShowHelp;

	TDSMPMenu	*PlayListMenu=DSMP->GetMenu(DSMP_MENU_PLAYLIST_HELP);
	Menu=DSMP->GetMenu(DSMP_MENU_PLAYLIST_HELP_EXTRA);
	Menu=PlayListMenu->Insert(Menu->MenuIndex+1,"DSMP Extender+");
	Menu->OnClick=ShowHelp;

/*
	FIcon=new TIcon();
	FIcon->Handle=::LoadIcon(HInstance,"MAINICON");
*/
	TRegistry	*Reg=new TRegistry();
	Reg->RootKey=HKEY_LOCAL_MACHINE;
	try
	{
		Reg->OpenKey("Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\IEXPLORE.EXE",false);
		IEPath=Reg->ReadString("");
	}
	__finally
	{
		delete Reg;
	}

	hUser32=::LoadLibrary("user32.dll");
	FSetLayeredWindowAttributes=NULL;
	if (hUser32)
	then {
		FSetLayeredWindowAttributes=(TSetLayeredWindowAttributes)::GetProcAddress(hUser32,"SetLayeredWindowAttributes");
		if (FSetLayeredWindowAttributes==NULL)
		then {
			::FreeLibrary(hUser32);
			hUser32=0;
		}
	}

	Load();
	Save();

	if (FAlpha != 100)
	then {
		int	n=FAlpha;
		FAlpha=-1;
		SetAlpha(n);
	}

	if (FSumiPita)
	then	FDSMP->Events=DSMP->Events<<evMove;
	else	FDSMP->Events=DSMP->Events>>evMove;
}

/*****	fXgN^	*****/

__fastcall	TDSMPExtender::~TDSMPExtender(void)
{
	Save();

	if (hUser32)
	then {
		::FreeLibrary(hUser32);
		hUser32=0;
	}
	if (FormExtender)
	then {
		delete	FormExtender;
		FormExtender=NULL;
	}
	if (FTaskTray)
	then	DeleteTaskTray();


//	delete	FIcon;
	delete	FDSMP;
}

/*****	ݒ̃[h	*****/

void __fastcall	TDSMPExtender::Load(void)
{
	TStringList	*SList=new TStringList();
	int			i;

	TIniFile	*File=new TIniFile(ChangeFileExt(DSMPIntf->GetDllPath(),".ini"));

	i=File->ReadInteger("DSMPExtender","Version",0);
	if (i<6300)
	then {
		try {
			File->EraseSection("ShortCut");
		}
		catch(...)
		{
		}
	}

	for(i=0;	ShortCuts[i].ID != 0;	i++)
	{
		ShortCuts[i].Text=File->ReadString("ShortCut",ShortCuts[i].Action,ShortCuts[i].Text);
	}

	SList->CommaText=File->ReadString("DSMPExtender","Position","");
	while(SList->Count<2)
	{
		SList->Add("");
	}
	FPosition.x=SList->Strings[0].ToIntDef(-1);
	FPosition.y=SList->Strings[1].ToIntDef(-1);
	FPage=File->ReadInteger("DSMPExtender","Page",0);
	TaskTray=File->ReadBool("DSMPExtender","TaskTray",true);
	LeftClick=(TDSMPExtLeftClick)File->ReadInteger("DSMPExtender","LeftClick",0);
	DDGraphics=File->ReadBool("DSMPExtender","DDGraphics",true);
	FlashTitleEnable=File->ReadBool("DSMPExtender","FlashTitle",true);
	SumiPita=File->ReadBool("DSMPExtender","SumiPita",true);
	FAlpha=File->ReadInteger("DSMPExtender","Alpha",100);
	FShortCutEnabled=File->ReadBool("DSMPExtender","ShortCut",true);

	delete	File;
	delete	SList;
}

/*****	ݒ̃Z[u	*****/

void __fastcall	TDSMPExtender::Save(void)
{
	TStringList	*SList=new TStringList();
	int			i;
	
	TIniFile	*File=new TIniFile(ChangeFileExt(DSMPIntf->GetDllPath(),".ini"));

	File->WriteInteger("DSMPExtender","Version",Version);
	SList->Clear();
	SList->Add(FPosition.x);
	SList->Add(FPosition.y);
	File->WriteString("DSMPExtender","Position",SList->CommaText);
	File->WriteInteger("DSMPExtender","Page",FPage);
	File->WriteBool("DSMPExtender","TaskTray",TaskTray);
	File->WriteInteger("DSMPExtender","LeftClick",LeftClick);
	File->WriteBool("DSMPExtender","DDGraphics",DDGraphics);
	File->WriteBool("DSMPExtender","FlashTitle",FlashTitleEnable);
	File->WriteBool("DSMPExtender","SumiPita",SumiPita);
	File->WriteInteger("DSMPExtender","Alpha",FAlpha);
	File->WriteBool("DSMPExtender","ShortCut",FShortCutEnabled);

	try {
		File->EraseSection("ShortCut");
	}
	catch(...)
	{
	}

	for(i=0;	ShortCuts[i].ID != 0;	i++)
	{
		File->WriteString("ShortCut",ShortCuts[i].Action,ShortCuts[i].Text);
	}

	delete	File;
	delete	SList;
}

/*****	L[̓tB^[	*****/

void __fastcall	TDSMPExtender::KeyDown(WORD &Key,TShiftState &Shift)
{
	TDSMPMenu	*Menu;
	int		i,n;
	int		ID;

	if (FShortCutEnabled==false)
	then	return;

	WORD	key=Key;
	if (Shift.Contains(ssShift))
	then	key |=scShift;
	if (Shift.Contains(ssCtrl))
	then	key |=scCtrl;
	if (Shift.Contains(ssAlt))
	then	key |=scAlt;

	for(i=0;	ShortCuts[i].ID !=0;	i++)
	{
		if (ShortCuts[i].Key==key)
		then {
			ID=ShortCuts[i].ID;
			Key=0;
			Shift.Clear();
			switch(ID)
			{
				case DSMP_ID_PLAYSTOP:
					PlayStop();
					break;
				case DSMP_ID_REWINDTOP:
					DSMP->Position=0;
					break;
				case DSMP_MENU_PLAYER_VOLUME+1:
					Key=VK_F6;
					Shift=TShiftState()<<ssCtrl;
					break;
				case DSMP_MENU_PLAYER_VOLUME+2:
					Key=VK_F6;
					Shift=TShiftState()<<ssShift;
					break;
				case DSMP_ID_VOLUP:
					DSMP->Volume=DSMP->Volume+50;
					break;
				case DSMP_ID_VOLDOWN:
					DSMP->Volume=DSMP->Volume-50;
					break;
				case DSMP_ID_MUTE:
					DSMP->Mute=!DSMP->Mute;
					break;
				case DSMP_ID_DISPLYRICS:
					n=DSMP->DisplayMode+1;
					if (n>dsmpDispSpeanaDecay)
					then	n=dsmpDispNone;
					DSMP->DisplayMode=(TDSMPDisplayMode)n;
					break;
				case DSMP_ID_HELP:
					Menu=DSMP->GetMenu(DSMP_MENU_PLAYER_HELP);
					Menu->Click();
//					Key=VK_F1;
					break;
				case DSMP_ID_FORM:
					if (::IsIconic(Application->Handle))
					then	Application->Restore();
					DSMP->Visible=!DSMP->Visible;
					break;
				case DSMP_ID_FULLSCREEN:
					if (DSMP->Zoom<0)
					then	DSMP->Zoom=-DSMP->Zoom;
					else if (DSMP->Zoom==0)
					then	DSMP->Zoom=100;
					else	DSMP->Zoom=0;
					break;
				case DSMP_ID_EXTENDER:
					MenuPropertyClick(this);
					break;
				case DSMP_ID_EDITLYRICS:
					DSMP->PlayList->EditLyrics(DSMP->Track);
					break;
				case DSMP_ID_REWIND:
				case DSMP_ID_FF:
					switch(FSeek)
					{
						case DSMP_ID_REWIND:
							DSMP->Rewind(false);
							break;
						case DSMP_ID_FF:
							DSMP->FF(false);
							break;
					}
					if (FSeek != ID)
					then {
						FSeek=ID;
						DSMP->Events=DSMP->Events<<evTimer;
					}
					else {
						FSeek=0;
						DSMP->Events=DSMP->Events>>evTimer;
					}
					break;
				default:
					DSMP->Click(ID);
					break;
			}
			break;
		}
	}
}

/*****	Đ/~gO	*****/

void __fastcall	TDSMPExtender::PlayStop(void)
{
	switch(DSMP->PlayStatus)
	{
//		case DSMP_PLAYSTATUS_NOTREADY:
//			break;
		case DSMP_PLAYSTATUS_PLAY:
		case DSMP_PLAYSTATUS_RECORD:
			DSMP->Stop();
			break;
		case DSMP_PLAYSTATUS_PAUSE:
			DSMP->Pause();
			break;
		default:
			DSMP->Play();
			break;
	}
}

/*****	TaskTray̐ݒ	*****/

void __fastcall	TDSMPExtender::SetTaskTray(bool f)
{
	if (FTaskTray != f)
	then {
		FTaskTray=f;
		if (f)
		then	AddTaskTray();
		else	DeleteTaskTray();
	}
}

/*****	^XNgCɓ	*****/

void __fastcall	TDSMPExtender::AddTaskTray(void)
{
	PostToTaskTray(NIM_ADD,"");
}

/*****	^XNgCo	*****/

void __fastcall	TDSMPExtender::DeleteTaskTray(void)
{
	PostToTaskTray(NIM_DELETE,"");
}

/*****	^XNgCbZ[W𑗂	*****/

bool __fastcall TDSMPExtender::PostToTaskTray(DWORD Msg,AnsiString Tip)
{
	NOTIFYICONDATA	tnd;

	tnd.cbSize=sizeof(NOTIFYICONDATA);
	tnd.hWnd=DSMP->Handle;
	tnd.uID=DSMP_NOTIFY_USER;
	tnd.uFlags=NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage=DSMP->WM_DSMP;
	tnd.hIcon=DSMPIntf->GetPlayerForm()->Icon->Handle;
	if ((Tip.IsEmpty()) OR (Tip.Length()>=64))
	then	strcpy(tnd.szTip,"DSMP");
	else	strcpy(tnd.szTip,Tip.c_str());

	return (Shell_NotifyIcon(Msg,&tnd));
}

/*****	WPbg摜pX̎擾	*****/

AnsiString __fastcall	TDSMPExtender::GetJacket(void)
{
	AnsiString	S;

	int		Track=FDSMP->Track;
	if ((Track>=1) AND (!IEPath.IsEmpty()))
	then {
		TTrackInfo	Info=FDSMP->TrackInfo[Track];
		if ((Info.Device==dsmpCD) OR (Info.Device==dsmpCDA))
		then {
			S="A:\\PICTURES\\JACKET01.00J";
			S[1]=(char)(Info.Drive+'A');
			if (FileExists(S)==false)
			then	S="";
		}
	}
	return(S);
}

/*****	j[\	*****/

void __fastcall TDSMPExtender::OnDisplayMenu(TObject* Sender)
{
	if (Sender!= FDSMP->PlayerMenu)
	then	return;

	if (Jacket.IsEmpty())
	then	MenuJacket->Enabled=false;
	else	MenuJacket->Enabled=true;
}

/*****	wv	*****/

void __fastcall TDSMPExtender::ShowHelp(TObject *Sender)
{
	AnsiString	S=ChangeFileExt(DSMPIntf->GetDllPath(),".chm");

	ShellExecute(DSMPForm->Handle,NULL,S.c_str(),NULL,NULL,SW_SHOWNORMAL);
}

/*****	j[vpeBNbN	*****/
/*
	\[Xߖׁ̈AKvɂȂtH[쐬
*/
void __fastcall	TDSMPExtender::MenuPropertyClick(TObject *Sender)
{
	if (FormExtender==NULL)
	then	FormExtender=new TFormExtender(DSMPIntf->GetPlayerForm());

	FormExtender->Show();
}

/*****	j[WPbgNbN	*****/

void __fastcall	TDSMPExtender::MenuJacketClick(TObject *Sender)
{
	AnsiString	S=Jacket;

	if (!S.IsEmpty())
	then	::ShellExecute(NULL,"open",IEPath.c_str(),S.c_str(),NULL,SW_SHOWNORMAL);
}

/*****	j[vC[摜Rs[	*****/

void __fastcall	TDSMPExtender::MenuCopyFormClick(TObject *Sender)
{
	DSMP->GetFormImage("");			//Nbv{[hɃRs[
}

/*****	ACRĕ`	*****/

void __fastcall	TDSMPExtender::MenuRedrawIconClick(TObject *Sender)
{
	SHChangeNotify(SHCNE_ASSOCCHANGED,0,0,0);
}

/*****	fUCݒ肳ꂽ	*****/

void __fastcall TDSMPExtender::OnDesign(TObject* Sender)
{
	int		n=FAlpha;
	if (FAlpha != 100)
	then {
		FAlpha=-1;
		SetAlpha(n);
	}
}

/*****	\؂	*****/

bool __fastcall	TDSMPExtender::IsAlpha(void)
{
	if (FSetLayeredWindowAttributes)
	then	return(true);

	return(false);
}

/*****		*****/

void __fastcall TDSMPExtender::SetAlpha(int Alpha)
{
	LONG		Style;
	int			n;
	TColor		cl;
	DWORD		Flag;
	AnsiString	S;

	if (FAlpha != Alpha)
	then {
		FAlpha=Alpha;
		if (FSetLayeredWindowAttributes)
		then {
			cl=clNone;
			Flag=LWA_ALPHA;

			S=DSMP->Design;
			if (!S.IsEmpty())
			then {
				TIniFile	*File=new TIniFile(S);
				if (File->ReadBool("Form","Transparent",0))
				then {
					cl=(TColor)File->ReadInteger("Form","BackColor",clNone);
				}
				delete	File;
			}
			if (cl != clNone)
			then	Flag |=LWA_COLORKEY;

			n=FAlpha*255/100;
			if (n>=256)
			then	n=255;

			Style=GetWindowLong(DSMP->DSMPHandle,GWL_EXSTYLE);
			SetWindowLong(DSMP->DSMPHandle,GWL_EXSTYLE,Style | WS_EX_LAYERED);
			FSetLayeredWindowAttributes(DSMP->DSMPHandle,cl,n,Flag);
		}
		else {
			FAlpha=100;
		}
	}
}

/*****	^Cgo[EBhE擾	*****/

HWND __fastcall	TDSMPExtender::GetTitleWindow(void)
{
	UINT	dir=GW_HWNDPREV;
	HWND	hwnd=GetForegroundWindow();
	DWORD	Style=GetWindowLong(hwnd,GWL_STYLE);

	while((hwnd)
		AND ((hwnd==DSMPWnd)
			OR ((Style & WS_TITLEBAR) != WS_TITLEBAR)
			OR (IsWindowVisible(hwnd)==FALSE)
			OR (IsIconic(hwnd)==TRUE)))
	{
		hwnd=GetNextWindow(hwnd,dir);
		if (hwnd==NULL)
		then {
			if (dir==GW_HWNDNEXT)
			then	return(NULL);
			hwnd=GetTopWindow(NULL);	//GetForegroundWindow();
			dir=GW_HWNDNEXT;
		}
		if (hwnd)
		then	Style=GetWindowLong(hwnd,GWL_STYLE);
	}

	return(hwnd);
}

/*****	EBhE^Cg擾	*****/

AnsiString __fastcall	TDSMPExtender::GetWindowTitle(HWND hwnd)
{
	int		sz=GetWindowTextLength(hwnd);
	char	*bf=new char[sz+16];
	AnsiString	S;

	if (GetWindowText(hwnd,bf,sz+16))
	then	S=bf;

	delete	bf;

	return(S);
}

/*****	^Cgɖ߂	*****/

void __fastcall	TDSMPExtender::OriginatedTitle(void)
{

	if ((FFlashWnd) AND (IsWindow(FFlashWnd)))
	then {
//		HWND	hwnd=GetForegroundWindow();

		SetWindowText(FFlashWnd,FOrgTitle.c_str());
/*
		FlashWindow(FFlashWnd,FALSE);
		SetForegroundWindow(GetForegroundWindow());
*/
		FLASHWINFO	fwi;

		fwi.cbSize=sizeof(FLASHWINFO);
		fwi.hwnd=FFlashWnd;
		fwi.dwFlags=FLASHW_STOP;
		fwi.uCount=0;
		fwi.dwTimeout=0;

		FlashWindowEx(&fwi);

		FFlashWnd=NULL;
	}
}

/*****	^CgtbV	*****/

void __fastcall TDSMPExtender::FlashTitle(void)
{
	FTitle="";

	if (FFlashTitleEnable==false)
	then	return;

	if (FDSMP->Track<1)
	then	return;

	TTrackInfo	Info=FDSMP->TrackInfo[FDSMP->Track];

	if (!Info.Artist.IsEmpty())
	then {
		FTitle=Info.Artist;
		FTitle+=" / ";
	}

	if (Info.Title.IsEmpty())
	then	FTitle+=ExtractFileName(Info.FileName);
	else	FTitle+=Info.Title;

	OriginatedTitle();

	FFlashCt=4000;

	FFlashWnd=GetTitleWindow();
	if (FFlashWnd==NULL)
	then {
		DSMP->Events=DSMP->Events<<evTimer;
		return;
	}
	FOrgTitle=GetWindowTitle(FFlashWnd);

	SetWindowText(FFlashWnd,FTitle.c_str());
	FFlashState=TRUE;

	FLASHWINFO	fwi;

	fwi.cbSize=sizeof(FLASHWINFO);
	fwi.hwnd=FFlashWnd;
	fwi.dwFlags=FLASHW_CAPTION | FLASHW_TIMER;
	fwi.uCount=16;
	fwi.dwTimeout=0;
	FlashWindowEx(&fwi);

//	FlashWindow(FFlashWnd,TRUE);

	DSMP->Events=DSMP->Events<<evTimer;
}

/*****	gbNI[v	*****/

void __fastcall TDSMPExtender::OnOpenTrack(TObject* Sender,int Param)
{
	FlashTitle();

	if (FTaskTray)
	then {
		PostToTaskTray(NIM_MODIFY,FTitle);
	}
}

/*****	gbNN[Y	*****/

void __fastcall TDSMPExtender::OnCloseTrack(TObject* Sender,int Param)
{
	OriginatedTitle();
	FFlashCt=0;
	if (FSeek==0)
	then	DSMP->Events=DSMP->Events>>evTimer;

	if (FTaskTray)
	then {
		PostToTaskTray(NIM_MODIFY,"");
	}
}

/*****	ĐԂς	*****/

void __fastcall TDSMPExtender::OnPlayStatus(TObject* Sender,int Param)
{
/*
	switch(Param)
	{
		case DSMP_PLAYSTATUS_STOP:
			FFlashCt=0;
			if ((FFlashWnd) AND (IsWindow(FFlashWnd)))
			then {
				SetWindowText(FFlashWnd,FOrgTitle.c_str());
				if (GetForegroundWindow()==FFlashWnd)
				then	FlashWindow(FFlashWnd,TRUE);
				else	FlashWindow(FFlashWnd,FALSE);
				FFlashWnd=NULL;
				if (FSeek==0)
				then	DSMP->Events=DSMP->Events>>evTimer;
			}
			break;
//		case DSMP_PLAYSTATUS_OPEN:
		case DSMP_PLAYSTATUS_PLAY:
		case DSMP_PLAYSTATUS_RECORD:
			FlashTitle();
			break;
	}
*/
}

/*****	OnIntTimer	*****/

void __fastcall	TDSMPExtender::DSMPOnIntTimer(TObject* Sender,int Param)
{
	static	int	FTimer=0;
	static	int	F500ms=500;
	static	int	F100ms=100;
	HWND	hwnd;

	if (FTimer==0)
	then	FTimer=Param;

	int	ms=Param-FTimer;
	FTimer=Param;
	if (ms<0)
	then	ms=10;

	F500ms-=ms;
	F100ms-=ms;

	if (F500ms<=0)
	then {
		F500ms=500;

		if (FFlashCt)
		then {
			FFlashCt-=500;

			hwnd=GetForegroundWindow();
			if ((FFlashWnd==NULL) OR (IsWindow(FFlashWnd)==FALSE))
			then {
				FFlashWnd=GetTitleWindow();
				if (FFlashWnd)
				then {
					FOrgTitle=GetWindowTitle(FFlashWnd);
					SetWindowText(FFlashWnd,FTitle.c_str());

					FLASHWINFO	fwi;

					fwi.cbSize=sizeof(FLASHWINFO);
					fwi.hwnd=FFlashWnd;
					fwi.dwFlags=FLASHW_CAPTION | FLASHW_TIMER;
					fwi.uCount=16;
					fwi.dwTimeout=0;
					FlashWindowEx(&fwi);

				}
			}
			if (hwnd != FFlashWnd)
			then {
				if ((hwnd != DSMPWnd)
					AND ((GetWindowLong(hwnd,GWL_STYLE) & WS_TITLEBAR)==WS_TITLEBAR)
					AND (IsWindowVisible(hwnd))
					AND (IsIconic(hwnd)==FALSE))
				then {
					OriginatedTitle();
					FFlashWnd=hwnd;
					FOrgTitle=GetWindowTitle(FFlashWnd);
					SetWindowText(FFlashWnd,FTitle.c_str());

					FLASHWINFO	fwi;

					fwi.cbSize=sizeof(FLASHWINFO);
					fwi.hwnd=FFlashWnd;
					fwi.dwFlags=FLASHW_CAPTION | FLASHW_TIMER;
					fwi.uCount=16;
					fwi.dwTimeout=0;
					FlashWindowEx(&fwi);

				}
			}
			if (FFlashCt<=0)
			then {
				OriginatedTitle();
				FFlashCt=0;
				if (FSeek==0)
				then	DSMP->Events=DSMP->Events>>evTimer;
			}
			else {
				if (FFlashWnd)
				then {
					FFlashState != FFlashState;

//					FlashWindow(FFlashWnd,TRUE);
				}
			}
		}
	}

	if (F100ms<=0)
	then {
		F100ms=100;
		switch(FSeek)
		{
			case DSMP_ID_REWIND:
				DSMP->Rewind(true);
				break;
			case DSMP_ID_FF:
				DSMP->FF(true);
				break;
		}
	}
}

/*****	OnMove	*****/

void __fastcall	TDSMPExtender::OnMove(TObject* Sender,int Left,int Top)
{
	if (FSumiPita==false)
	then	return;

	int		Right=Left+DSMP->Width;
	int		Bottom=Top+DSMP->Height;
	int		State,Corner;

	RECT	rc;

	SystemParametersInfo(SPI_GETWORKAREA,0,&rc,0);

	FCorner=-1;
	if ((Left>=rc.left-16) AND (Left<rc.left+16)
		AND (Top>=rc.top-16) AND (Top<rc.top+16))
	then {
		FCorner=0;
	}
	else if ((Left>=rc.left-16) AND (Left<rc.left+16)
		AND (Bottom>=rc.bottom-16) AND (Bottom<rc.bottom+16))
	then {
		FCorner=1;
	}
	else if ((Right>=rc.right-16) AND (Right<rc.right+16)
		AND (Top>=rc.top-16) AND (Top<rc.top+16))
	then {
		FCorner=2;
	}
	else if ((Right>=rc.right-16) AND (Right<rc.right+16)
		AND (Bottom>=rc.bottom-16) AND (Bottom<rc.bottom+16))
	then {
		FCorner=3;
	}
	else {
		FSumiPitaEnabled=true;
	}

	if ((FSumiPitaEnabled) AND (FCorner>=0))
	then {
		if (FCorner & 2)
		then	DSMP->Left=rc.right-DSMP->Width;
		else	DSMP->Left=rc.left;
		if (FCorner & 1)
		then	DSMP->Top=rc.bottom-DSMP->Height;
		else	DSMP->Top=rc.top;
	}
}

/*****	OnMoved	*****/

void __fastcall	TDSMPExtender::OnMoved(TObject* Sender,int Left,int Top)
{
	if (FCorner>=0)
	then	FSumiPitaEnabled=false;
	else	FSumiPitaEnabled=true;
}

/*****	DSMP_NOTIFY_USER	*****/

void __fastcall	TDSMPExtender::DSMPOnUser(TObject* Sender,DWORD Event,int Param)
{
	if (Event==DSMP_NOTIFY_CLOSE)
	then {
		if (FormExtender)
		then {
			delete	FormExtender;
			FormExtender=NULL;
		}
		if (FSumiPita)
		then	FDSMP->Events=DSMP->Events<<evMove;
		else	FDSMP->Events=DSMP->Events>>evMove;

		Save();
	}
	if (Event==DSMP_NOTIFY_RUN)
	then {
		int	n=FAlpha;
		FAlpha=-1;
		SetAlpha(n);
	}
	else {
		switch(Param)
		{
			case WM_LBUTTONDOWN:
				switch(LeftClick)
				{
					case lcVisible:
						if (::IsIconic(Application->Handle))
						then	Application->Restore();
						DSMP->Visible=!DSMP->Visible;
						break;
					case lcMinimize:
						if (DSMP->Visible==false)
						then	DSMP->Visible=true;
						if (::IsIconic(Application->Handle))
						then	Application->Restore();
						else	Application->Minimize();
						break;
				}
				break;
			case WM_RBUTTONDOWN:
				DSMP->ShowMenu();
				break;
			case WM_RBUTTONDBLCLK:
			case WM_LBUTTONDBLCLK:
				DSMP->Visible=true;
				Application->Restore();
				MenuPropertyClick(this);
				break;
		}
	}
}

/*----------------------------------------------*/
/*				TFormExtenderNX				*/
/*----------------------------------------------*/

__fastcall TFormExtender::TFormExtender(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString	S;
	int			i;
	TShortCuts	*shortcut;

	if (DSMPExtender->Position.x==-1)
	then {
		Position=poScreenCenter;
	}
	else {
		Position=poDesigned;
		Left=DSMPExtender->Position.x;
		Top=DSMPExtender->Position.y;
	}

	LabelVersion->Caption=Format("Version %d.%.02d.%d",OPENARRAY(TVarRec,((Version/1000),(Version%1000/10),(Version%10))));

	FShortCutList=new TList();

	SGridShortCut->RowCount=1;
	SGridShortCut->Rows[0]->CommaText="ANV,V[gJbgL[";
	for(i=0;	ShortCuts[i].ID != 0;	i++)
	{
		shortcut=new TShortCuts();
		*shortcut=ShortCuts[i];
		FShortCutList->Add(shortcut);

		SGridShortCut->RowCount=SGridShortCut->RowCount+1;
		SGridShortCut->Cells[0][i+1]=shortcut->Action;
		SGridShortCut->Cells[1][i+1]=shortcut->Text;
	}
	SGridShortCut->FixedRows=1;
	CheckBoxShortCut->Checked=DSMPExtender->ShortCutEnabled;

	CheckBoxTaskTray->Checked=DSMPExtender->TaskTray;
	RadioGroupLeftClick->ItemIndex=DSMPExtender->LeftClick;
	CheckBoxDDGraphics->Checked=DSMPExtender->DDGraphics;
	CheckBoxFlashTitle->Checked=DSMPExtender->FlashTitleEnable;
	CheckBoxSumiPita->Checked=DSMPExtender->SumiPita;

	FAlpha=DSMPExtender->Alpha;
	TrackBarAlpha->Position=FAlpha;
	if (DSMPExtender->IsAlpha())
	then {
		TrackBarAlpha->Enabled=true;
		LabelAlpha->Enabled=true;
		FAlpha=DSMPExtender->Alpha;
	}
	else {
		TrackBarAlpha->Enabled=false;
		LabelAlpha->Enabled=false;
		FAlpha=100;
	}
	LabelAlpha->Caption=Format("\r\n%d%%",OPENARRAY(TVarRec,(FAlpha)));

	PageControl->ActivePage=PageControl->Pages[DSMPExtender->Page];

	Visible=true;

	::SetForegroundWindow(Handle);
}

/*****	tH[	*****/

void __fastcall TFormExtender::FormClose(TObject *Sender,TCloseAction &Action)
{
	DSMPExtender->Position.x=Left;
	DSMPExtender->Position.y=Top;
	DSMPExtender->Page=PageControl->ActivePage->Tag;

	DSMPExtender->DSMP->NotifyEvent(DSMPExtender->DSMP->Handle,DSMP_NOTIFY_USER | DSMP_NOTIFY_CLOSE,0);		//[_tH[ɂȂ
}

/*****	OK	*****/

void __fastcall TFormExtender::BtnOKClick(TObject *Sender)
{
	TShortCuts	*shortcut;
    int			i;

	for(i=0;	i<FShortCutList->Count;	i++)
	{
		shortcut=(TShortCuts*)(FShortCutList->Items[i]);
		ShortCuts[i]=*shortcut;
	}
	DSMPExtender->ShortCutEnabled=CheckBoxShortCut->Checked;
	DSMPExtender->TaskTray=CheckBoxTaskTray->Checked;
	DSMPExtender->LeftClick=(TDSMPExtLeftClick)RadioGroupLeftClick->ItemIndex;
	DSMPExtender->DDGraphics=CheckBoxDDGraphics->Checked;
	DSMPExtender->FlashTitleEnable=CheckBoxFlashTitle->Checked;
	DSMPExtender->SumiPita=CheckBoxSumiPita->Checked;
	DSMPExtender->Alpha=TrackBarAlpha->Position;

	Close();
}

/*****	LZ	*****/

void __fastcall TFormExtender::BtnCancelClick(TObject *Sender)
{
	DSMPExtender->Alpha=FAlpha;

	Close();
}

/*****	wv	*****/

void __fastcall TFormExtender::BtnHelpClick(TObject *Sender)
{
	DSMPExtender->ShowHelp(Sender);
}

/*****	z[y[W	*****/

void __fastcall TFormExtender::BtnHomePageClick(TObject *Sender)
{
	::ShellExecute(NULL,"open",LabelHomePage->Caption.c_str(),NULL,NULL,SW_SHOW);
}

/*****	V[gJbgL[̐ݒ	*****/

void __fastcall TFormExtender::SGridShortCutKeyDown(TObject *Sender,
	  WORD &Key, TShiftState Shift)
{
	switch(Key)
	{
		case VK_UP:
		case VK_DOWN:
		case VK_LEFT:
		case VK_RIGHT:
			if  (*((char*)&Shift)==0)
			then	return;
			break;
		case VK_RETURN:
		case VK_ESCAPE:
		case VK_TAB:
		case VK_SHIFT:
		case VK_CONTROL:
		case VK_MENU:
		case 0:
			return;
	}
	if (*((char*)&Shift)==0)
	then {
		if ((Key>='0') AND (Key<='9'))
		then	return;
		if ((Key>=VK_NUMPAD0) AND (Key<=VK_NUMPAD9))
		then	return;
	}

	UINT	ScanCode=::MapVirtualKey(Key,0);
	if (ScanCode==0)
	then	return;

	int		n=SGridShortCut->Row-1;

	if (n<0)
	then	return;

	TShortCuts	*shortcut=(TShortCuts*)(FShortCutList->Items[n]);
	shortcut->Key=Key;
	if (Shift.Contains(ssShift))
	then	shortcut->Key |=scShift;
	if (Shift.Contains(ssCtrl))
	then	shortcut->Key |=scCtrl;
	if (Shift.Contains(ssAlt))
	then	shortcut->Key |=scAlt;

	SGridShortCut->Cells[1][n+1]=shortcut->Text;

	switch(Key)
	{
		case VK_F4:
		case VK_HOME:
		case VK_END:
		case VK_LEFT:
		case VK_RIGHT:
		case VK_NEXT:
		case VK_PRIOR:
			Key=0;
			break;
	}
}

/*****	gbNo[ύX	*****/

void __fastcall TFormExtender::TrackBarAlphaChange(TObject *Sender)
{
	DSMPExtender->Alpha=TrackBarAlpha->Position;

	LabelAlpha->Caption=Format("\r\n%d%%",OPENARRAY(TVarRec,(DSMPExtender->Alpha)));
}

/*****	End	*****/

