/*	Filename:main.h								*/
/************************************************/
/*												*/
/*				DSMP Extender+					*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*			 	CW[wb_[		*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>

#include "dsmp.h"
#include <Grids.hpp>
#include <Dialogs.hpp>

#define	DSMP_ID_PLAYSTOP		(DSMP_ID_STOP+0x10000)
#define	DSMP_ID_BEGIN			(DSMP_ID_REWINDBEGIN+0x10000)
#define	DSMP_ID_VOLUP			(DSMP_ID_VOLUME+0x10000)
#define	DSMP_ID_VOLDOWN			(DSMP_ID_VOLUME+0x20000)
#define	DSMP_ID_DISPNONE		(DSMP_ID_LYRICS+0x10000)
#define	DSMP_ID_DISPLYRICS		(DSMP_ID_LYRICS+0x20000)
#define	DSMP_ID_DISPSPEANA		(DSMP_ID_LYRICS+0x30000)
#define	DSMP_ID_DISPSPEANAPEAK	(DSMP_ID_LYRICS+0x40000)
#define	DSMP_ID_DISPSPEANADECAY	(DSMP_ID_LYRICS+0x50000)
#define	DSMP_ID_EXTENDER		(DSMP_ID_MAX+0x10000)
#define	DSMP_ID_HELP			(DSMP_ID_MAX+0x10001)
#define	DSMP_ID_REWINDTOP		(DSMP_ID_MAX+0x10002)
#define	DSMP_ID_EDITLYRICS		(DSMP_ID_MAX+0x10003)
#define	DSMP_ID_FULLSCREEN		(DSMP_ID_MAX+0x10004)

typedef	BOOL (WINAPI *TSetLayeredWindowAttributes)(HWND hwnd,COLORREF crKey,BYTE bAlpha,DWORD dwFlags);

/*----------------------------------------------*/
/*				TShortCutsNX				*/
/*----------------------------------------------*/

class	TShortCuts
{
private:
protected:
	AnsiString __fastcall	GetShortCutText(void);
	void __fastcall	SetShortCutText(AnsiString Text);

public:
	char		*Action;
	int			ID;
	TShortCut	Key;

	__property	AnsiString	Text={read=GetShortCutText,write=SetShortCutText};
};

/*----------------------------------------------*/
/*				TFormExtenderNX				*/
/*----------------------------------------------*/

class TFormExtender : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TPageControl *PageControl;
	TTabSheet *TabSheetExtender;
	TTabSheet *TabSheetSortcut;
	TCheckBox *CheckBoxTaskTray;
	TTabSheet *TabSheetAbout;
	TLabel *LabelDSMPExtender;
	TLabel *LabelVersion;
	TLabel *LabelCopyright;
	TPanel *PanelBottom;
	TBitBtn *BtnOK;
	TBitBtn *BtnCancel;
	TBitBtn *BtnHelp;
	TLabel *LabelHomePage;
	TBitBtn *BtnHomePage;
	TStringGrid *SGridShortCut;
	TPanel *Panel1;
	TRadioGroup *RadioGroupLeftClick;
	TCheckBox *CheckBoxDDGraphics;
	TCheckBox *CheckBoxFlashTitle;
	TCheckBox *CheckBoxSumiPita;
	TTrackBar *TrackBarAlpha;
	TLabel *LabelAlpha;
	TCheckBox *CheckBoxShortCut;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnOKClick(TObject *Sender);
	void __fastcall BtnCancelClick(TObject *Sender);
	void __fastcall BtnHelpClick(TObject *Sender);
	void __fastcall SGridShortCutKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall BtnHomePageClick(TObject *Sender);
	void __fastcall TrackBarAlphaChange(TObject *Sender);
private:	// [U[錾
	TList*		FShortCutList;
	int			FAlpha;

protected:

public:		// [U[錾
	__fastcall TFormExtender(TComponent* Owner);
};

/*----------------------------------------------*/
/*				TDSMPExtenderNX				*/
/*----------------------------------------------*/

enum	TDSMPExtLeftClick	{lcVisible,lcMinimize};

class	TDSMPExtender:public TComponent
{
private:
	TDSMP				*FDSMP;
	TIcon				*FIcon;
	TFormExtender		*FormExtender;
	int					FSeek;
	bool				FTaskTray;
	TDSMPExtLeftClick	FLeftClick;
	TPoint				FPosition;
	int					FPage;
	TDSMPMenu			*MenuExtender;
	TDSMPMenu			*MenuJacket;
	AnsiString			FIEPath;
	bool				FDDGraphics;
	bool				FFlashTitleEnable;
	HWND				FFlashWnd;
	AnsiString			FOrgTitle;
	AnsiString			FTitle;
	int					FFlashCt;
	BOOL				FFlashState;
	bool				FSumiPita;
	bool				FSumiPitaEnabled;
	int					FCorner;
	bool				FShortCutEnabled;

	HINSTANCE			hUser32;
	TSetLayeredWindowAttributes	FSetLayeredWindowAttributes;
	int					FAlpha;

protected:
	void __fastcall	PlayStop(void);
	void __fastcall	SetTaskTray(bool f);
	void __fastcall	AddTaskTray(void);
	void __fastcall	DeleteTaskTray(void);
	bool __fastcall PostToTaskTray(DWORD Msg,AnsiString Tip);
	AnsiString __fastcall	GetJacket(void);
	void __fastcall OnDisplayMenu(TObject* Sender);
	void __fastcall	MenuPropertyClick(TObject *Sender);
	void __fastcall	MenuJacketClick(TObject *Sender);
	void __fastcall	MenuCopyFormClick(TObject *Sender);
	void __fastcall	MenuRedrawIconClick(TObject *Sender);
	void __fastcall OnDesign(TObject* Sender);
	void __fastcall SetAlpha(int Alpha);
	void __fastcall	DSMPOnIntTimer(TObject* Sender,int Param);
	void __fastcall	DSMPOnUser(TObject* Sender,DWORD Event,int Param);
	void __fastcall	OriginatedTitle(void);
	void __fastcall FlashTitle(void);
	HWND __fastcall	GetTitleWindow(void);
	AnsiString __fastcall	GetWindowTitle(HWND hwnd);
	void __fastcall OnPlayStatus(TObject* Sender,int Param);
	void __fastcall OnOpenTrack(TObject* Sender,int Param);
	void __fastcall OnCloseTrack(TObject* Sender,int Param);
	void __fastcall	OnMove(TObject* Sender,int Left,int Top);
	void __fastcall	OnMoved(TObject* Sender,int Left,int Top);

public:
	__fastcall	TDSMPExtender(TComponent *Owner);
	__fastcall	~TDSMPExtender(void);
	void __fastcall	Load(void);
	void __fastcall	Save(void);
	void __fastcall	KeyDown(WORD &Key,TShiftState &Shift);
	bool __fastcall	IsAlpha(void);
	void __fastcall ShowHelp(TObject *Sender);

	__property	TDSMP	*DSMP={read=FDSMP};
	__property	TPoint	Position={read=FPosition,write=FPosition};
	__property	int		Page={read=FPage,write=FPage};
	__property	bool	TaskTray={read=FTaskTray,write=SetTaskTray};
	__property	AnsiString	Jacket={read=GetJacket};
	__property	TDSMPExtLeftClick	LeftClick={read=FLeftClick,write=FLeftClick};
	__property	AnsiString	IEPath={read=FIEPath,write=FIEPath};
	__property	bool	DDGraphics={read=FDDGraphics,write=FDDGraphics};
	__property	bool	FlashTitleEnable={read=FFlashTitleEnable,write=FFlashTitleEnable};
	__property	bool	SumiPita={read=FSumiPita,write=FSumiPita};
	__property	int		Alpha={read=FAlpha,write=SetAlpha};
	__property	bool	ShortCutEnabled={read=FShortCutEnabled,write=FShortCutEnabled};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern PACKAGE TFormExtender *FormExtender;
extern	int			Version;
extern	TShortCuts	ShortCuts[];

#endif

/*****	End	*****/

