/*	Filename:Main.cpp							*/
/************************************************/
/*												*/
/*			LyrJvZ{iDSMPvOCj		*/
/*												*/
/*				CtH[W[		*/
/*												*/
/*					Ver.6.00  					*/
/*												*/
/*		Copyright 1997,2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <IniFiles.hpp>
#include <shellapi.h>
#pragma hdrstop

#include "main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

int					Version=6003;
TFormLyrCapsule*	FormLyrCapsule;
TDSMPInterface*		DSMPIntf;
HANDLE				hMutex;
AnsiString			DllName;

/*----------------------------------------------*/
/*					Export֐					*/
/*----------------------------------------------*/

/*****	vOC̎s	*****/

void	pinRun(TDSMPInterface *Intf)
{
	DSMPIntf=Intf;

	if (DSMPIntf->CheckVersion(DSMP_DLLVERSION)==false)
	then {
		MessageDlg("LyrCapsule+\nño[WDSMPɂ͑ΉĂ܂\nΉłg",mtWarning,TMsgDlgButtons()<<mbOK,0);
		DSMPIntf->Abort();
		return;
	}
	hMutex=::CreateMutex(NULL,FALSE,"LyrCapsule");
	if ((hMutex==0) OR (::GetLastError()==ERROR_ALREADY_EXISTS))
	then {
		DSMPIntf->Abort();		  					//2dNȂI
		return;
	}
/*
	HWND	hwnd=::FindWindow("TFormLyrCapsule",NULL);
	if (hwnd)
	then {
		DSMPIntf->Abort();
		return;
	}
*/
	DllName=ExtractFileName(DSMPIntf->GetDllPath());

#ifdef	VCL6DLLINTF
	FormLyrCapsule=new TFormLyrCapsule((TForm*)DSMPIntf->GetPlayerForm());
#else
	FormLyrCapsule=new TFormLyrCapsule(NULL);
#endif

	FormLyrCapsule->Created();
}

/*****	vOC̏I	*****/

void	pinAbort(void)
{
	if (FormLyrCapsule)
	then {
		if (FormLyrCapsule->Closed==false)
		then {
			FormLyrCapsule->SaveIni();
			delete	FormLyrCapsule;
		}
		FormLyrCapsule=NULL;
	}
	if (hMutex)
	then {
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		hMutex=0;
	}
}

/*****	Cxgʒm	*****/
/*
void	pinNotifyEvent(DWORD Event,int Param)
{
}
*/
/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****  pl̃x[x̕擾  *****/

int __fastcall  GetPanelBevelWidth(TPanel *Panel)
{
	int     bw=0;
	if (Panel->BevelInner != bvNone)
	then    bw+=Panel->BevelWidth;
	if (Panel->BevelOuter != bvNone)
	then    bw+=Panel->BevelWidth;

    return(bw);
}

/*----------------------------------------------*/
/*				TMeterNX					*/
/*----------------------------------------------*/

/*****	Label쐬	*****/

void __fastcall	TMeter::MakeLabel(TPanel* Panel,TOrientation dir,bool fPeak,int Bands,int Index,TColor Blue,TColor Yellow,TColor Red)
{
	int     bw=GetPanelBevelWidth(Panel);
	int		cw=Panel->Width-bw*2;
	int		ch=Panel->Height-bw*2;
	int		Left,Top,Bottom;
	int		Width,Height;
	TColor	cl;
	int		i;

	FBlue=Blue;
	FYellow=Yellow;
	FRed=Red;
	FColor=Panel->Color;

	if (dir==tHolizontal)
	then {
		Width=cw/10;
		Height=ch/Bands;
		Left=bw+(cw-Width*10)/2;
		Top=bw+(ch-Height*Bands)/2+Index*Height;
		cw=Width-1;
		if (cw<=0)
		then	cw=1;
		if (fPeak)
		then {
			Left+=cw;
			cw=1;
		}
		switch(Bands)
		{
			case 1:
				ch=Height;
				break;
			case 2:
				ch=Height-1;
				if (Index==1)
				then	Top+=1;
				break;
			default:
				ch=Height-2;
				Top+=1;
				break;
		}
	}
	else {
		Width=cw/Bands;
		Height=ch/10;
		Left=bw+(cw-Width*Bands)/2+Index*Width;
		Top=bw+(ch-Height*10)/2;
		if (fPeak)
		then	ch=1;
		else {
			ch=Height-1;
			if (ch<=0)
			then	ch=1;
			else	Top+=1;
		}
		Bottom=Top+Height*9;
		switch(Bands)
		{
			case 1:
				cw=Width;
				break;
			case 2:
				cw=Width-1;
				if (Index==1)
				then	Left+=1;
				break;
			default:
				cw=Width-2;
				Left+=1;
				break;
		}
	}

	for(i=0;	i<10;	i++)
	{
		if (i>=8)
		then    cl=Red;
		else if (i>=6)
		then    cl=Yellow;
		else	cl=Blue;

		if (Label[i]==NULL)
		then    Label[i]=new TLabel(Panel->Owner);

		Label[i]->Parent=Panel;
		Label[i]->Caption="";
		Label[i]->AutoSize=false;
		if (dir==tHolizontal)
		then {
			Label[i]->Left=Left+i*Width;
			Label[i]->Top=Top;
		}
		else {
			Label[i]->Left=Left;
			Label[i]->Top=Bottom-i*Height;//+1;
		}
		Label[i]->Height=ch;
		Label[i]->Width=cw;
		Label[i]->Color=cl;
		Label[i]->Cursor=crDefault;	//crHandCursor;
		Label[i]->ParentShowHint=true;
		Label[i]->ShowHint=true;
		Label[i]->Tag=Panel->Tag+((i+1)<<8)+0x1000;
		Label[i]->OnClick=Panel->OnClick;
		Label[i]->OnMouseDown=Panel->OnMouseDown;
		Label[i]->OnMouseMove=Panel->OnMouseMove;
		Label[i]->OnMouseUp=Panel->OnMouseUp;
		Label[i]->Visible=true;
	}
}

/*****	[^[\	*****/

void __fastcall	TMeter::Display(int level)
{
	TColor		cl;
	int     	i;

	if (level<0)
	then	level=0;
	else if (level>10)
	then	level=10;

	Level=level;

	for(i=0;    i<Level;  i++)
	{
		if (i>=8)
		then	cl=FRed;
		else if (i>=6)
		then	cl=FYellow;
		else	cl=FBlue;
		if (Label[i]->Color != cl)
		then	Label[i]->Color=cl;
/*ߏꍇ
		if (Label[i]->Visible==false)
		then {
			Label[i]->Visible=true;
		}
*/
	}

	for(;   i<10;   i++)
	{
		if (Label[i]->Color != FColor)
		then	Label[i]->Color=FColor;
/*ߏꍇ
		if (Label[i]->Visible)
		then {
			Label[i]->Visible=false;
		}
*/
	}

}

/*----------------------------------------------*/
/*				TFormLyrCapsuleNX		   	*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall TFormLyrCapsule::TFormLyrCapsule(TComponent* Owner)
	: TForm(Owner)
{
	int		i;

	MeterVolume[0].MakeLabel((TPanel*)PanelVolume,tHolizontal,false,2,0,PanelVolume->Font->Color,(TColor)30583,(TColor)4456584);
	MeterVolume[1].MakeLabel((TPanel*)PanelVolume,tHolizontal,false,2,1,PanelVolume->Font->Color,(TColor)30583,(TColor)4456584);
	MeterVolume[0].Display(0);
	MeterVolume[1].Display(0);
	for(i=0;	i<10;	i++)
	{
		MeterSpeana[i].MakeLabel(PanelSpeana,tVertical,false,10,i,PanelSpeana->Font->Color,(TColor)30583,(TColor)4456584);
//		MeterSpeanaPeak[i].MakeLabel(PanelSpeana,tVertical,true,10,i,PanelSpeana->Font->Color,(TColor)30583,(TColor)4456584);
	}
	SpeanaOff();

	FDisplayMode=1;
	FPositionSet=-1;
}

/*****	fXgN^	*****/

__fastcall	TFormLyrCapsule::~TFormLyrCapsule(void)
{
	DSMP->Unbind();
}

/*****	tH[쐬ꂽ	*****/

void __fastcall	TFormLyrCapsule::Created(void)
{
	AnsiString	S;
	int			i;

#ifdef	VCL6DLLINTF
	FormStyle=((TForm*)(DSMPIntf->GetPlayerForm()))->FormStyle;
#else
	LONG	Style=GetWindowLong(DSMPIntf->GetHandle(),GWL_EXSTYLE);
	if (Style & WS_EX_TOPMOST)
	then	FormStyle=fsStayOnTop;
	else	FormStyle=fsNormal;
#endif

	::SetForegroundWindow(Handle);
	RegionForm=new dsvRegion(ImageForm);
	RegionForm->TransparentColor=clTeal;
	RegionForm->Create();
	RegionForm->Set();

	DSMP->Bind();

	TDSMPMenu*		FMenu=DSMP->PlayerMenu->Add("LyrCapsule+ \");
	FMenu->OnClick=LyrMenuClick;

	FPosition=0;
	Left=(Screen->Width-Width)/2;
	Top=(Screen->Height-Height)/2;
	FDisplayMode=1;

	S=DSMPIntf->GetDllPath();
	TIniFile	*File=new TIniFile(ChangeFileExt(S,".ini"));

	FPosition=File->ReadInteger("LyrCaps","Position",FPosition);
	Left=File->ReadInteger("LyrCaps","Left",Left);
	Top=File->ReadInteger("LyrCaps","Top",Top);
	FOffsetLeft=File->ReadInteger("LyrCaps","OffsetLeft",Left-DSMP->Left);
	FOffsetTop=File->ReadInteger("LyrCaps","OffsetTop",Top-DSMP->Top);
	FDisplayMode=File->ReadInteger("LyrCaps","DisplayMode",FDisplayMode);

	delete	File;

	FDefBackColor=clBlack;
	FDefColor=(TColor)16776960;
	if (!DSMP->Design.IsEmpty())
	then {
		File=new TIniFile(DSMP->Design);

		FDefBackColor=(TColor)File->ReadInteger("Lyrics","BackColor",clBlack);
		FDefColor=(TColor)File->ReadInteger("Lyrics","Color",clBlack);

		delete	File;
	}
	FLyrBackColor=FDefBackColor;
	FLyrColor=FDefColor;

	TMenuItem	*Menu;

	for(i=0;	i<PopupPosition->Count;	i++)
	{
		Menu=PopupPosition->Items[i];
		if (Menu->Tag==FPosition)
		then	break;
	}
	if (i>=PopupPosition->Count)
	then	Menu=PopupPositionFree;

	PopupPositionClick(Menu);

	SetDisplayMode(FDisplayMode);
	DSMPPlayStatus(this,DSMP->PlayStatus);
	DisplayRepeat();
	DisplayRandom();
	DisplayTimer();

	Visible=true;
}

/*****	EBhE쐬p[^̍쐬	*****/

void __fastcall TFormLyrCapsule::CreateParams(Controls::TCreateParams &Params)
{
	inherited::CreateParams(Params);

	Params.Style &=~(WS_CLIPSIBLINGS | WS_CLIPCHILDREN);
	Params.ExStyle |=WS_EX_ACCEPTFILES;				//hbvt@C󂯕t悤ɂ
}

/*****	N[Y	*****/

void __fastcall TFormLyrCapsule::FormClose(TObject *Sender, TCloseAction &Action)
{
	Closed=true;

	DSMP->Unbind();

	Application->ProcessMessages();

	SaveIni();
}

/*****	Save INI	*****/

void __fastcall	TFormLyrCapsule::SaveIni(void)
{
	AnsiString	S=DSMPIntf->GetDllPath();
	S=ChangeFileExt(S,".ini");
	TIniFile	*File=new TIniFile(S);

	File->WriteInteger("LyrCaps","Version",Version);
	File->WriteInteger("LyrCaps","Position",FPosition);
	File->WriteInteger("LyrCaps","Left",Left);
	File->WriteInteger("LyrCaps","Top",Top);
	File->WriteInteger("LyrCaps","OffsetLeft",FOffsetLeft);
	File->WriteInteger("LyrCaps","OffsetTop",FOffsetTop);
	File->WriteInteger("LyrCaps","DisplayMode",FDisplayMode);

	delete	File;
}

/*****	tH[ړ	*****/

void __fastcall TFormLyrCapsule::DSMPMove(TObject *Sender, int left, int top)
{
	int		width=DSMP->Width;
	int		height=DSMP->Height;

	switch(FPosition)
	{
		case fpUpper:
			Left=left+(width-Width)/2;
			Top=top-Height;
			break;
		case fpUnder:
			Left=left+(width-Width)/2;
			Top=top+DSMP->Height;
			break;
		case fpLeft:
			Left=left-Width;
			Top=top+(height-Height)/2;
			break;
		case fpRight:
			Left=left+DSMP->Width;
			Top=top+(height-Height)/2;
			break;
		case fpOffset:
			Left=left+FOffsetLeft;
			Top=top+FOffsetTop;
			break;
	}
}

/*****	OnStayOnTop	*****/

void __fastcall TFormLyrCapsule::DSMPStayOnTop(TObject *Sender, bool Flag)
{
	if (Closed)
	then	return;

	if (Flag)
	then	FormStyle=fsStayOnTop;
	else	FormStyle=fsNormal;

	RegionForm->Set();
}

/*****	̎\ύXꂽ	*****/

void __fastcall TFormLyrCapsule::DSMPLyrics(TObject *Sender,int Line)
{
	if (Closed)
	then	return;

	if ((FDisplayMode != 1) AND (Line>=0))
	then	return;

	TLyrics	*Lyr=DSMP->Text;

	if (Lyr->Font->Height==0)
	then	return;

	LabelLyrics->Caption=Lyr->Text;
	if (LabelLyrics->Alignment != Lyr->Alignment)
	then	LabelLyrics->Alignment=Lyr->Alignment;
	if (LabelLyrics->WordWrap != Lyr->WordWrap)
	then	LabelLyrics->WordWrap=Lyr->WordWrap;
	if (LabelLyrics->ShowAccelChar != Lyr->ShowAccelChar)
	then	LabelLyrics->ShowAccelChar=Lyr->ShowAccelChar;
	if (FLyrBackColor != Lyr->BackColor)
	then {
		FLyrBackColor=Lyr->BackColor;
		if (FLyrBackColor != FDefBackColor)
		then	LabelLyrics->Color=FLyrBackColor;
	}

	if ((LabelLyrics->Font->Name != Lyr->Font->Name)
		OR (LabelLyrics->Font->Charset != Lyr->Font->Charset)
		OR (LabelLyrics->Font->Height != Lyr->Font->Height)
		OR (LabelLyrics->Font->Style != Lyr->Font->Style)
		OR (FLyrColor != Lyr->Font->Color))
	then {
		LabelLyrics->Font->Assign(Lyr->Font);
		LabelLyrics->Font->Height=Lyr->Font->Height;
		FLyrColor=Lyr->Font->Color;
		if (FLyrColor==FDefColor)
		then	LabelLyrics->Font->Color=PanelLyrics->Font->Color;
	}
}

/*****	XyAi\It	*****/

void __fastcall	TFormLyrCapsule::SpeanaOff(void)
{
	int		i;

	for(i=0;	i<10;	i++)
	{
		MeterSpeana[i].Display(0);
//		MeterSpeanaPeak[i].Display(0);
	}
}

/*****	XyAi\I	*****/

void __fastcall	TFormLyrCapsule::SpeanaOn(void)
{
	int		i,j;

	for(i=0;	i<10;	i++)
	{
		MeterSpeana[i].Display(0);
//		MeterSpeanaPeak[i].Display(0);
		for(j=0;	j<10;	j++)
		{
			MeterSpeana[i].Label[j]->Visible=true;
//			MeterSpeanaPeak[i].Label[j]->Visible=true;
		}
	}
}

/*****	XyAiύX	*****/

void __fastcall TFormLyrCapsule::DSMPSpeana(TObject *Sender, int *Level)
{
	int		i;

	if (Closed)
	then	return;

	for(i=0;	i<10;	i++)
	{
		MeterSpeana[i].Display(Level[i]);
	}

}

/*****	{[[^[	*****/

void __fastcall TFormLyrCapsule::DSMPVolume(TObject *Sender, int L,int R)
{
	if (Closed)
	then	return;

	MeterVolume[0].Display(L);
	MeterVolume[1].Display(R);
}

/*****	}EX_E	*****/

void __fastcall TFormLyrCapsule::FormMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (FMoveWindow)
	then	return;

	SetCapture(Handle);
	FMoveWindow=true;			//FIntTime;
	FMoveWindowLeft=Left;
	FMoveWindowTop=Top;
	FMoveWindowPos.x=X;
    FMoveWindowPos.y=Y;
    FMoveWindowPos=((TControl*)Sender)->ClientToScreen(FMoveWindowPos);
    FMoveWindowPos.x-=Left;
    FMoveWindowPos.y-=Top;
}

/*****  }EXړ  *****/

void __fastcall TFormLyrCapsule::FormMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	if (FMoveWindow)
    then {
        tagPOINT    pt;

        pt.x=X;
		pt.y=Y;
        pt=((TControl*)Sender)->ClientToScreen(pt);

		SetPosition(pt.x-FMoveWindowPos.x,pt.y-FMoveWindowPos.y);
	}
}

/*****  }EXAbv    *****/

void __fastcall TFormLyrCapsule::FormMouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();

	if (FMoveWindow)
	then {
		tagPOINT    pt;

        pt.x=X;
        pt.y=Y;
        pt=((TControl*)Sender)->ClientToScreen(pt);

		SetPosition(pt.x-FMoveWindowPos.x,pt.y-FMoveWindowPos.y);

		FMoveWindow=false;
	}
}

/*****  \ʒu̐ݒ	*****/

void __fastcall	TFormLyrCapsule::SetPosition(int left,int top)
{
	int		width=DSMP->Width;
	int		height=DSMP->Height;

	Left=left;
	Top=top;
	switch(FPosition)
	{
		case fpFree:
			break;
		case fpUpper:
			DSMP->Left=left-(width-Width)/2;
			DSMP->Top=top+Height;
			break;
		case fpUnder:
			DSMP->Left=left-(width-Width)/2;
			DSMP->Top=top-DSMP->Height;
			break;
		case fpLeft:
			DSMP->Left=left+Width;
			DSMP->Top=top-(height-Height)/2;
			break;
		case fpRight:
			DSMP->Left=left-DSMP->Width;
			DSMP->Top=top-(height-Height)/2;
			break;
		case fpOffset:
			FOffsetLeft=left-DSMP->Left;
			FOffsetTop=top-DSMP->Top;
			break;
	}
}

/*****	\ʒuݒ	*****/

void __fastcall TFormLyrCapsule::PopupPositionClick(TObject *Sender)
{
	TMenuItem	*Menu=(TMenuItem*)Sender;

	Menu->Checked=true;
	FPosition=Menu->Tag;
	FOffsetLeft=Left-DSMP->Left;
	FOffsetTop=Top-DSMP->Top;

	DSMPMove(this,DSMP->Left,DSMP->Top);
}

/*****	Cxg̐ݒ	*****/

void __fastcall	TFormLyrCapsule::SetEvent(int Mode)
{
	switch(Mode)
	{
		case 0:
			PanelSpeana->Visible=false;
			PanelLyrics->Visible=false;
			PanelDisplay->Visible=true;
			DSMP->Events=TDSMPEventSets()<<evCounter<<evVolume<<evMove;
			break;
		default:
		case 1:
			PanelSpeana->Visible=false;
			PanelDisplay->Visible=false;
			PanelLyrics->Visible=true;
			if (FDisplayMode==1)
			then {
				DSMPLoadLyrics(this);
				DSMPLyrics(this,-1);
			}
			DSMP->Events=TDSMPEventSets()<<evLyrics<<evMove;
			break;
		case 2:
			PanelLyrics->Visible=false;
			PanelDisplay->Visible=false;
			SpeanaOff();
			PanelSpeana->Visible=true;
			DSMP->Events=TDSMPEventSets()<<evSpeana<<evMove;
			break;
	}
}

/*****	\[h̐ݒ	*****/

void __fastcall	TFormLyrCapsule::SetDisplayMode(int Mode)
{
	FDisplayMode=Mode;

	LabelLyrics->Caption="";
	switch(FDisplayMode)
	{

		case 0:
			PopupTitle->Checked=true;
			DSMPDisplayTitle(this,DSMP->Track);
			break;
		default:
		case 1:
			PopupLyrics->Checked=true;
			FDisplayMode=1;
			break;
		case 2:
			PopupSpeana->Checked=true;
			break;
	}
	SetEvent(FDisplayMode);
}

/*****	LyricsplNbN	*****/

void __fastcall TFormLyrCapsule::PanelSpeanaClick(TObject *Sender)
{
	FDisplayMode++;
	if (FDisplayMode>=3)
	then	FDisplayMode=0;

	SetDisplayMode(FDisplayMode);
}

/*****	|bvAbvj[\ꂽ	*****/

void __fastcall TFormLyrCapsule::PopupMenuPopup(TObject *Sender)
{
	if (DSMP->Visible==false)
	then	PopupPlayerVisible->Caption="vC[\";
	else	PopupPlayerVisible->Caption="vC[\";
}

/*****	\[h	*****/

void __fastcall TFormLyrCapsule::PopupLyricsClick(TObject *Sender)
{
	TMenuItem	*Menu=(TMenuItem*)Sender;

	SetDisplayMode(Menu->Tag);

}

/*****	vC[\	*****/

void __fastcall TFormLyrCapsule::PopupPlayerVisibleClick(TObject *Sender)
{
	DSMP->Visible=! DSMP->Visible;
}

/*****	gbÑI[v	*****/

void __fastcall TFormLyrCapsule::DSMPOpenTrack(TObject *Sender, int Track)
{
	TTrackInfo	Info=DSMP->TrackInfo[Track];

//	LabelTitle->Caption=Info.Title;
	LabelTitle->Hint=Info.Title;
//	LabelArtist->Caption=Info.Artist;
	LabelArtist->Hint=Info.Artist;

	DSMPLoadLyrics(this);

	switch(FDisplayMode)
	{
		case 0:
			break;
		default:
		case 1:
			Info=DSMP->TrackInfo[Track];
			if ((Info.Lyrics.IsEmpty()) OR (DSMP->LyricsList->Lines<=1))
			then	SetEvent(2);
			else	SetEvent(1);
			break;
		case 2:
			SetEvent(2);
			break;
	}
}

/*****	gbNN[Y	*****/

void __fastcall TFormLyrCapsule::DSMPCloseTrack(TObject *Sender, int Param)
{
	LabelLyrics->Color=PanelLyrics->Color;
}

/*****	̎t@C[hꂽ	*****/

void __fastcall TFormLyrCapsule::DSMPLoadLyrics(TObject *Sender)
{
	PanelLyrics->Hint=DSMP->LyricsList->Comment;
	LabelLyrics->Width=DSMP->LyricsList->Width;
	LabelLyrics->Height=DSMP->LyricsList->Height;
	LabelLyrics->Left=(PanelLyrics->Width-LabelLyrics->Width)/2;
	LabelLyrics->Top=(PanelLyrics->Height-LabelLyrics->Height)/2;
	LabelLyrics->Color=PanelLyrics->Color;

#ifdef	VCL6DLLINTF
	TPanel	*PanelLyr=(TPanel*)DSMPIntf->GetControl(DSMP_ID_LYRICS);
	FDefBackColor=PanelLyr->Color;
	FLyrBackColor=FDefBackColor;
	FDefColor=PanelLyr->Font->Color;
	FLyrColor=FDefColor;
#endif
}

/*****	^Cg\	*****/

void __fastcall TFormLyrCapsule::DSMPDisplayTitle(TObject *Sender, int Track)
{
	AnsiString	S;
	TTrackInfo	Info=DSMP->TrackInfo[Track];

	S=Info.Title;
	if (S.IsEmpty())
	then	S=ExtractFileName(Info.FileName);
	if (S.IsEmpty())
	then	S=AnsiString::Format("DSMP Capsule+ Ver.%1d.%3.3d",OPENARRAY(TVarRec,((Version/1000),(Version%1000))));
	LabelTitle->Caption=S;
	LabelTitle->Hint=S;
	LabelArtist->Caption=Info.Artist;
	LabelArtist->Hint=Info.Artist;
	PanelLyrics->Hint=DSMP->LyricsList->Comment;
}

/*****	gbN\	*****/

void __fastcall TFormLyrCapsule::DSMPDisplayTrack(TObject *Sender, int Track)
{
	LabelTrack->Caption=AnsiString::Format("%.3d",OPENARRAY(TVarRec,(Track)));
	FLength=DSMP->Length;
}

/*****	JE^[\	*****/

void __fastcall TFormLyrCapsule::DSMPCounter(TObject *Sender, int ms)
{
	int		sec=ms/1000;
	int		min=sec/60;
	sec=sec % 60;
	int		length=FLength;
	if (length==0)
	then	length=60000;
	if (DSMP->Tracks==0)
	then {
		int	counter=DSMP->Counter;
		sec=counter%1000;
		counter /=1000;
		min=counter%60;
		int		hour=counter/60;
		if (sec<0)
		then	sec=0;
		LabelTrack->Caption=AnsiString::Format("%.3d",OPENARRAY(TVarRec,(hour)));
		ms=sec;
		length=60;
	}

	LabelTime->Caption=AnsiString::Format("%.2d:%.2d",OPENARRAY(TVarRec,((min),(sec))));
	LabelPosition->Width=LabelPositionBack->Width*ms/length;
	if (LabelPosition->Width==0)
	then	LabelPosition->Width=1;
	if (LabelPosition->Width>LabelPositionBack->Width)
	then	LabelPosition->Width=LabelPositionBack->Width;
}

/*****  |WVCWP[^MouseDown *****/

void __fastcall TFormLyrCapsule::LabelPositionMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	FPositionSet=0;
	LabelPositionMouseMove(Sender,Shift,X,Y);
}

/*****  |WVCWP[^MouseUp   *****/

void __fastcall TFormLyrCapsule::LabelPositionMouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	LabelPositionMouseMove(Sender,Shift,X,Y);
	DSMP->Position=FPositionSet;
	FPositionSet=-1;
}

/*****  |WVCWP[^MouseMove *****/

void __fastcall TFormLyrCapsule::LabelPositionMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	if ((FPositionSet<0) OR (DSMP->Enabled==false) OR (DSMP->Length==0))
	then	return;

	TPoint	P(X,Y);

	if (Sender==LabelPosition)
	then {
		P=LabelPositionBack->ScreenToClient(((TLabel*)Sender)->ClientToScreen(P));
	}

	FPositionSet=DSMP->Length*(((double)P.x)/(LabelPositionBack->Width-4));
	FPositionSet=((FPositionSet+5)/10)*10;				//10msŎľܓ

	if (FPositionSet>=DSMP->Length)
	then	FPositionSet=DSMP->Length-1;
	if (FPositionSet<0)
	then	FPositionSet=0;

	DSMP->Counter=FPositionSet;
	DSMPCounter(this,FPositionSet);
}

/*****	C[W̕\	*****/

void __fastcall	TFormLyrCapsule::DisplayImage(TImage *Image,TImageList *ImageList,int n)
{
/*
	if (Image->Picture==NULL)
	then	return;
*/
	TRect	Rect(0,0,Image->Width,Image->Height);

	Image->Canvas->CopyMode=cmSrcCopy;
	Image->Canvas->Brush->Color=PanelDisplay->Color;
	Image->Canvas->Brush->Style=bsSolid;
	Image->Canvas->FillRect(Rect);

	if (n>=ImageList->Count)
	then	return;

	ImageList->Draw(Image->Canvas,0,0,n,true);

	Image->Invalidate();
}

/*****	s[g\	*****/

void __fastcall	TFormLyrCapsule::DisplayRepeat(void)
{
	int		n=0;

	if (DSMP->Repeat)
	then	n=1;

	DisplayImage(ImageRepeat,ImageList,n);
}

/*****	_\	*****/

void __fastcall	TFormLyrCapsule::DisplayRandom(void)
{
	int		n=2;

	if (DSMP->Random)
	then	n=3;

	DisplayImage(ImageRandom,ImageList,n);
}

/*****	^C}[\	*****/

void __fastcall	TFormLyrCapsule::DisplayTimer(void)
{
	int		n=4;

	if ((DSMP->OnTimer) OR (DSMP->OffTimer) OR (DSMP->ShutDownRecord))
	then	n=5;

	DisplayImage(ImageTimer,ImageList,n);
}

/*****	s[gʒm	*****/

void __fastcall TFormLyrCapsule::DSMPRepeat(TObject *Sender, bool Flag)
{
	DisplayRepeat();
}

/*****	_Đʒm	*****/

void __fastcall TFormLyrCapsule::DSMPRandom(TObject *Sender, bool Flag)
{
	DisplayRandom();
}

/*****	^C}[\ʒm	*****/

void __fastcall TFormLyrCapsule::DSMPDisplayTimer(TObject *Sender, int Param)
{
	DisplayTimer();
}

/*****	s[gNbN	*****/

void __fastcall TFormLyrCapsule::ImageRepeatClick(TObject *Sender)
{
	DSMP->Repeat=! DSMP->Repeat;
}

/*****	_NbN	*****/

void __fastcall TFormLyrCapsule::ImageRandomClick(TObject *Sender)
{
	DSMP->Random= ! DSMP->Random;
}

/*****	tXe[^Xʒm	*****/

void __fastcall TFormLyrCapsule::DSMPPlayStatus(TObject *Sender, int Param)
{
	int		n;

	switch(Param)
	{
		default:
		case	DSMP_PLAYSTATUS_STOP:
		case	DSMP_PLAYSTATUS_NOTREADY:
			n=0;
			break;
		case	DSMP_PLAYSTATUS_PLAY:
			n=2;
			break;
		case	DSMP_PLAYSTATUS_RECORD:
			n=3;
			break;

	}

	Graphics::TBitmap	*Bitmap=new Graphics::TBitmap();
	Bitmap->Width=12;
	Bitmap->Height=12;
	ImageListPlay->Draw(Bitmap->Canvas,0,0,n,true);
	BtnPlay->Glyph=Bitmap;
	delete	Bitmap;

	DisplayRepeat();
	DisplayRandom();
	DisplayTimer();
}

/*****	Up{^	*****/

void __fastcall TFormLyrCapsule::BtnUpClick(TObject *Sender)
{
	DSMP->Back();
}

/*****	Down{^	*****/

void __fastcall TFormLyrCapsule::BtnDownClick(TObject *Sender)
{
	DSMP->Next();
}

/*****	Play{^	*****/

void __fastcall TFormLyrCapsule::BtnPlayClick(TObject *Sender)
{
	switch(DSMP->PlayStatus)
	{
		case DSMP_PLAYSTATUS_PLAY:
		case DSMP_PLAYSTATUS_RECORD:
			DSMP->Stop();
			break;
		default:
			DSMP->Play();
			break;
	}
}

/*****	vCXg	*****/

void __fastcall TFormLyrCapsule::BtnPlayListClick(TObject *Sender)
{
	DSMP->PlayList->Visible=!DSMP->PlayList->Visible;
}

/*****	c[	*****/

void __fastcall TFormLyrCapsule::BtnToolClick(TObject *Sender)
{
	DSMP->Click(DSMP_ID_TOOL);
}

/*****	vC[{^	*****/

void __fastcall TFormLyrCapsule::BtnLogoClick(TObject *Sender)
{
	PopupPlayerVisibleClick(Sender);
}

/*****	j[I	*****/

void __fastcall TFormLyrCapsule::LyrMenuClick(TObject *Sender)
{
	TDSMPMenu*		Menu=(TDSMPMenu*)Sender;

	AnsiString	S="LyrCapsule+ ";

	if (Visible)
	then {
		Visible=false;
		S+="\";
		Menu->Caption=S;
	}
	else {
		Visible=true;
		S+="\";
		Menu->Caption=S;
	}
}

/*****	wv	*****/

void __fastcall TFormLyrCapsule::PopupHelpClick(TObject *Sender)
{
	AnsiString	S=ChangeFileExt(DSMPIntf->GetDllPath(),".htm");

	ShellExecute(Handle,NULL,S.c_str(),NULL,NULL,SW_SHOWNORMAL);
}

/*****	I	*****/

void __fastcall TFormLyrCapsule::PopupExitClick(TObject *Sender)
{
	DSMP->Abort();
}

/*****	t@Chbvꂽ	*****/

void __fastcall TFormLyrCapsule::WMDropFiles(TWMDropFiles& Msg)
{
	int			DropCount=::DragQueryFile((void*)(Msg.Drop),0xFFFFFFFF,NULL,0);	//hbvꂽt@C̐
	char		*bf=new char[MAX_PATH+16];										//t@C擾pobt@
	AnsiString	S;
	AnsiString	Ext;
	int			i;

	for(i=0;	i<DropCount;	i++)
	{
		::DragQueryFile((void*)(Msg.Drop),i,bf,MAX_PATH+16);	//t@C擾
		S=bf;													//AnsiStringɕϊiϊȂĂj
		Ext=AnsiLowerCase(ExtractFileExt(S));
		if (Ext==".dsmpd")
		then    DSMP->Design=S;
		else	DSMP->Add(S);
	}
	::DragFinish((void*)(Msg.Drop));					//D&DIʒm
	delete	bf;

	Msg.Result=0;										//bZ[W
}

/*****	L[ꂽ	*****/

void __fastcall TFormLyrCapsule::FormKeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
	DSMP->KeyDown(Key,Shift);
}

/*****	End	*****/

