/*	Filename:DSMPINTF.H							*/
/************************************************/
/*												*/
/*			DS}`fBAvC[			*/
/*												*/
/*					Ver.6.32   					*/
/*												*/
/*				DSMPC^[tF[X			*/
/*                             					*/
/*		Copyright 1999-2003 by DELTA SOFT		*/
/*												*/
/************************************************/

#ifndef DSMPINTFH
#define DSMPINTFH

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include	<mmsystem.h>

#ifndef	then
#define	then
#endif

#ifndef	AND
#define	AND	&&
#endif

#ifndef	OR
#define	OR	||
#endif

#if	(__BORLANDC__>=0x560)
#define	VCL6DLLINTF
#endif

/*-----	o[W`FbNp	-----*/

#define	DSMP_INTFVERSION	(6000)
#define	DSMP_DLLVERSION		(6000)
#define	DSMP_COMVERSION		(4300)
#define	DSMP_VERSION		(6320)

/*-----	Rg[	-----*/

#define	DSMP_ID_FORM				0x0001
#define	DSMP_ID_IMAGEFORM			0x0101
#define	DSMP_ID_CAPTION				0x0002
#define	DSMP_ID_LABELCAPTION		0x0102
#define	DSMP_ID_LABELCAPTIONSHADOW	0x0202
#define	DSMP_ID_LOGO				0x0003
#define	DSMP_ID_MINIMIZE			0x0004
#define	DSMP_ID_TOOL				0x0005
#define	DSMP_ID_CLOSE				0x0006
#define	DSMP_ID_MENU				0x0007
#define	DSMP_ID_PLAYLIST			0x0008
#define	DSMP_ID_EJECT				0x0009
#define	DSMP_ID_STOP				0x000A
#define	DSMP_ID_PAUSE				0x000B
#define	DSMP_ID_PLAY  				0x000C
#define	DSMP_ID_RECORD				0x000D
#define	DSMP_ID_REWIND				0x000E
#define	DSMP_ID_FF					0x000F
#define	DSMP_ID_BACK         		0x0010
#define	DSMP_ID_NEXT				0x0011
#define	DSMP_ID_VOLUME				0x0012
#define	DSMP_ID_LYRICS				0x0013
#define	DSMP_ID_LABELLYRICS			0x0113
#define	DSMP_ID_DISPLAYPANEL		0x0014
#define	DSMP_ID_DEVICE				0x0015
#define	DSMP_ID_REPEAT				0x0016
#define	DSMP_ID_REPEATBUTTON		0x0116
#define	DSMP_ID_RANDOM				0x0017
#define	DSMP_ID_RANDOMBUTTON		0x0117
#define	DSMP_ID_ARTIST				0x0018
#define	DSMP_ID_TITLE				0x0019
#define	DSMP_ID_TIMER				0x001A
#define	DSMP_ID_TIMERBUTTON			0x011A
#define	DSMP_ID_TRACK				0x001B
#define	DSMP_ID_TRACKCOUNTER		0x001C
#define	DSMP_ID_TRACK100           	0x011C
#define	DSMP_ID_TRACK10				0x021C
#define	DSMP_ID_TRACK1				0x031C
#define	DSMP_ID_TIME	   			0x001D
#define	DSMP_ID_TIMECOUNTER			0x001E
#define	DSMP_ID_TIME10M				0x011E
#define	DSMP_ID_TIME1M				0x021E
#define	DSMP_ID_TIME10S				0x031E
#define	DSMP_ID_TIME1S				0x041E
#define	DSMP_ID_TIMECOLLON			0x051E
#define	DSMP_ID_POSITION			0x001F
#define	DSMP_ID_LABELPOSITION		0x011F
#define	DSMP_ID_LABELPOSITIONBACK	0x021F
#define	DSMP_ID_VOLUMEMETER			0x0020
#define	DSMP_ID_SPEANA				0x0021
#define	DSMP_ID_MUTE				0x0022
#define	DSMP_ID_MUTEBUTTON			0x0122
#define	DSMP_ID_DSMPPRO				0x0023
#define	DSMP_ID_MAX					0x0024

#define	DSMP_PLAYLIST_FORM			0x1000
#define	DSMP_PLAYLIST_MAX			0x1001

#define	DSMP_VIDEO_FORM				0x2000
#define	DSMP_VIDEO_MAX				0x2001

#define	DSMP_PROPERTY_FORM			0x3000
#define	DSMP_PROPERTY_MAX			0x3001

#define	DSMP_MENU_PLAYER				0x4000
#define	DSMP_MENU_PLAYER_PLAYLIST		0x4100
#define	DSMP_MENU_PLAYER_CD				0x4200	//Tuj[0x4201`
#define	DSMP_MENU_PLAYER_MIDI			0x4300	//Tuj[0x4301`
#define	DSMP_MENU_PLAYER_PLAY			0x4400
#define	DSMP_MENU_PLAYER_RANDOM			0x4410
#define	DSMP_MENU_PLAYER_REPEAT			0x4420
#define	DSMP_MENU_PLAYER_INTRO			0x4430
#define	DSMP_MENU_PLAYER_AUTOPLAY		0x4440
#define	DSMP_MENU_PLAYER_DISPLAY		0x4500
#define	DSMP_MENU_PLAYER_DISPNONE		0x4510
#define	DSMP_MENU_PLAYER_DISPLYRICS		0x4520
#define	DSMP_MENU_PLAYER_DISPSPEANA		0x4530
#define	DSMP_MENU_PLAYER_SPEANA			0x4531
#define	DSMP_MENU_PLAYER_SPEANAPEAK		0x4532
#define	DSMP_MENU_PLAYER_SPEANADECAY	0x4533
#define	DSMP_MENU_PLAYER_PASSTIME		0x4540
#define	DSMP_MENU_PLAYER_REMAINTIME		0x4550
#define	DSMP_MENU_PLAYER_VOLUMEMETER	0x4560
#define	DSMP_MENU_PLAYER_VOLUME			0x4600
#define	DSMP_MENU_PLAYER_MUTE			0x4610
#define	DSMP_MENU_PLAYER_PROPERTY		0x4700
#define	DSMP_MENU_PLAYER_TOOL			0x4800
#define	DSMP_MENU_PLAYER_HELP			0x4900
#define	DSMP_MENU_PLAYER_EXIT			0x4FFF

#define	DSMP_MENU_TOOL					0x8000

#define	DSMP_MENU_PLAYLIST				0x5000
#define	DSMP_MENU_PLAYLIST_FILE			0x5100
#define	DSMP_MENU_PLAYLIST_PLAY			0x5200
#define	DSMP_MENU_PLAYLIST_EDIT			0x5300
#define	DSMP_MENU_PLAYLIST_TOOL			0x5400
#define	DSMP_MENU_PLAYLIST_FILE_CD		0x5C00
#define	DSMP_MENU_PLAYLIST_FILE_ADDCD	0x5D00
#define	DSMP_MENU_PLAYLIST_PLAY_MIDI	0x5E00
#define	DSMP_MENU_PLAYLIST_HELP			0x5F00
#define	DSMP_MENU_PLAYLIST_HELP_EXTRA	0x5FF0

#define	DSMP_MENU_PLAYLISTPOPUP			0x9000
#define	DSMP_MENU_PLAYLISTPOPUP_ADDCD	0x9500


/*-----	o[Wpj[	-----*/

#define	DSMP_MENU_PLAYER3322		0
#define	DSMP_MENU_TOOL3322			1
#define	DSMP_MENU_PLAYLIST3322		(-1)
#define	DSMP_MENU_PLAYLISTPOPUP3322	(-2)

/*-----	WM_DSMP_xxxx	-----*/

//FWM_APP=0x8000
//DSMPŎgp

#define	WM_DSMP_ADDFILE			WM_APP+1
#define	WM_DSMP_DESIGN			WM_APP+2

#define	WM_DSMP_START			WM_APP+0x80
#define WM_ENCODING_DATA		WM_APP+0x84
#define	WM_ENCODING_END			WM_APP+0x85
#define	WM_CLOSEPROPERTY		WM_APP+0x86
#define	WM_ABORTPLUGIN			WM_APP+0x87
#define	WM_DSMP_SHOWMENU		WM_APP+0x88
#define	WM_DSMP_SEEK			WM_APP+0x89
#define	WM_DSMP_STOP			WM_APP+0x8A

/*-----	DSMPւ̃R}hbZ[W(WM_DSMPWParam)	-----*/

//FWM_USER=0x0400

#define	DSMP_FIND				(WM_USER+1)
#define	DSMP_CLOSE				(WM_USER+2)
#define	DSMP_SETTOOL			(WM_USER+3)

/*-----	DSMP̒ʒmR[h(WM_DSMPWParam)	-----*/

#define	DSMP_NOTIFY_OPEN		0x00000001			//LParam:Handle
#define	DSMP_NOTIFY_CLOSE		0x00000002			//LParam:Handle
#define DSMP_NOTIFY_RUN			0x00000004			//LParam:Instance
#define DSMP_NOTIFY_ABORT		0x00000008			//LParam:Handle
#define	DSMP_NOTIFY_PLAYSTATUS	0x00000010			//LParam:DSMP_PLAYSTATUS_xxxx
#define	DSMP_NOTIFY_TIMER		0x00000020			//LParam:TickCount
#define	DSMP_NOTIFY_COUNTER		0x00000040			//LParam:Counter[ms]
#define DSMP_NOTIFY_POSITION	0x00000080			//LParam:Position[ms]
#define	DSMP_NOTIFY_VOLUME		0x00000100	   		//LParam:LOWORD(L),HIWORD(R)
#define	DSMP_NOTIFY_LYRICS		0x00000200			//LParam:Line
#define	DSMP_NOTIFY_MOVE		0x00000400			//LParam:LOWORD(Left),HIWORD(Top)
#define	DSMP_NOTIFY_MENU		0x00000800			//LParam:TMenuItem*
#define	DSMP_NOTIFY_SEND		0x08000000			//WParamʃ[h:Cmd,LParam:C
#define	DSMP_NOTIFY_SPEANA		0x10000000			//Wparam̉ʃoCgLParamɃx
#define	DSMP_NOTIFY_BUTTON		0x20000000			//WParam̉ʃ[hDSMP_BTN_xxxx
#define	DSMP_NOTIFY_STATUS		0x40000000			//WParam̉ʃ[hDSMP_STATUS_xxxx
#define	DSMP_NOTIFY_USER		0x80000000			//LParam:C

/*-----	DSMP_NOTIFY_STATUS(WParam̉ʃ[hj	------*/

#define	DSMP_STATUS_VISIBLE			1				//LParam:bool
#define	DSMP_STATUS_ACTIVE			2				//LParam:bool
#define	DSMP_STATUS_MINIMIZE		3				//LParam:bool
#define	DSMP_STATUS_STAYONTOP		4				//LParam:bool
#define	DSMP_STATUS_REPEAT	 		5				//LParam:bool
#define	DSMP_STATUS_RANDOM	 		6				//LParam:bool
#define	DSMP_STATUS_DISPLAYTIME		7				//LParam:bool
#define	DSMP_STATUS_DISPLAYTRACK	8				//LParam:Track
#define	DSMP_STATUS_DISPLAYTITLE	9				//LParam:Track
#define	DSMP_STATUS_DISPLAYDEVICE	10				//LParam:TDSMPDeviceType
#define	DSMP_STATUS_DISPLAYTIMER	11				//LParam:DSMP_TIMER_XXXX Conbination
#define	DSMP_STATUS_DISPLAYCAPTION	12
#define	DSMP_STATUS_VOLUME			13				//LParam:Value(0-1000)
#define	DSMP_STATUS_OPENTRACK		14				//LParam:Track
#define	DSMP_STATUS_CLOSETRACK		15				//LParam:Track
#define	DSMP_STATUS_LOADLYRICS		16				//LParam:Lines
#define	DSMP_STATUS_SAVEDSMPINI		17
#define	DSMP_STATUS_DESIGN			18
#define	DSMP_STATUS_CHANGEPLAYLIST	21				//Track
#define	DSMP_STATUS_DISPLAYMENU		22				//MenuID
#define	DSMP_STATUS_DISPLAYPLAYLIST	23				//LParam:bool
#define	DSMP_STATUS_DISPLAYPROPERTY	24				//LParam:bool
#define	DSMP_STATUS_CLICK			25				//LParam:ID
#define	DSMP_STATUS_DBLCLICK		26				//LParam:ID
#define	DSMP_STATUS_DELETEMENU		27				//LParam:TMenuItem*
#define	DSMP_STATUS_DISPLAYMODE		28				//LParam:Mode
#define	DSMP_STATUS_SETRATE			29				//LParam:Rate
#define	DSMP_STATUS_MOVED			30				//LParam:Left,Top
#define	DSMP_STATUS_ADJUSTLEVEL		31				//LParam:Vol=0/Speana=1/Rec=2
#define	DSMP_STATUS_MUTE			32				//LParam:bool
#define	DSMP_STATUS_ZOOM			33				//LParam:zoom

/*-----	DSMP_STATUS_TIMERiLParamj	-----*/

#define	DSMP_TIMER_ON				1
#define	DSMP_TIMER_OFF				2
#define	DSMP_TIMER_SHUTDOWN			4

/*-----	DSMP_NOTIFY_BUTTON(WParam̉ʃ[hj	-----*/

//LParam̓Rg[ԍ(DSMP_ID_xxxxxj

#define	DSMP_BTN_NORMAL			(0x0000)
#define	DSMP_BTN_DISABLE		(0x0001)
#define	DSMP_BTN_DOWN			(0x0002)
#define	DSMP_BTN_ACTIVE			(0x0003)

/*-----	DSMP_NOTIFY_PLAYSTATUSLParam	-----*/

#define DSMP_PLAYSTATUS_NOTREADY	(524)
#define DSMP_PLAYSTATUS_STOP		(525)
#define DSMP_PLAYSTATUS_PLAY		(526)
#define DSMP_PLAYSTATUS_RECORD		(527)
#define DSMP_PLAYSTATUS_SEEK		(528)
#define DSMP_PLAYSTATUS_PAUSE		(529)
#define DSMP_PLAYSTATUS_OPEN		(530)

/*
#ifndef	VCL_H
class	TForm;
class	TControl;
class	TComponent;
class	TPopupMenu;
class	TMainMenu;
#endif
*/
class	TPlugin;

/*----------------------------------------------*/
/*				TDSMPInterfaceNX			*/
/*----------------------------------------------*/

class	TDSMPInterface
{
public:
	virtual int		STDMETHODCALLTYPE	GetVersion(void);
	virtual bool	STDMETHODCALLTYPE	CheckVersion(int Version);
	virtual	void	STDMETHODCALLTYPE	Abort(void);
	virtual void	STDMETHODCALLTYPE	SetHandle(HWND Handle);
	virtual	DWORD	STDMETHODCALLTYPE	GetEvent(void);
	virtual void	STDMETHODCALLTYPE	SetEvent(DWORD Event);
	virtual	void	STDMETHODCALLTYPE	NotifyEvent(DWORD Handle,DWORD Event,int Param);
	virtual char*	STDMETHODCALLTYPE	GetDSMPPath(void);
	virtual	char*	STDMETHODCALLTYPE	GetDllPath(void);
	virtual HWND	STDMETHODCALLTYPE	GetHandle(void);
	virtual	void	STDMETHODCALLTYPE	SaveDSMPini(void);
	virtual	void	STDMETHODCALLTYPE	LoadDSMPini(void);
	virtual	void	STDMETHODCALLTYPE	Click(int ID);

	virtual TObject* STDMETHODCALLTYPE	GetControl(int ID);						//BCB6
	virtual	int		STDMETHODCALLTYPE	SetControlID(TComponent *Control);		//BCB6
	virtual	TForm*	STDMETHODCALLTYPE	GetPlayerForm(void);					//BCB6
	virtual	TForm*	STDMETHODCALLTYPE	GetPlayListForm(void);					//BCB6
	virtual	TForm*	STDMETHODCALLTYPE	GetPropertyForm(void);					//BCB6
	virtual TPopupMenu*	STDMETHODCALLTYPE	GetPlayerMenu(void);				//BCB6
	virtual	TPopupMenu*	STDMETHODCALLTYPE	GetToolMenu(void);					//BCB6
	virtual	TMainMenu*	STDMETHODCALLTYPE	GetPlayListMenu(void);				//BCB6
	virtual	TPopupMenu*	STDMETHODCALLTYPE	GetPlayListPopupMenu(void);			//BCB6
	virtual	TForm*	STDMETHODCALLTYPE	GetVideoForm(void);						//BCB6

	virtual	void*	STDMETHODCALLTYPE	GetGraphBuilder(void);
	virtual void	STDMETHODCALLTYPE	SetPluginName(char *Name);
	virtual char*	STDMETHODCALLTYPE	GetPluginName(DWORD Handle);
	virtual bool	STDMETHODCALLTYPE	FindPlugin(char *Name,HWND *Handle=NULL,DWORD *Instance=NULL);
	virtual DWORD	STDMETHODCALLTYPE	SendPlugin(DWORD Handle,WORD cmd,DWORD Param);
};

/*----------------------------------------------*/
/*				TDSMPIntfNX					*/
/*----------------------------------------------*/

class	TDSMPIntf:public TDSMPInterface
{
private:
protected:
public:
	TPlugin*	Plugin;
	HWND		COMHandle;

	TDSMPIntf(TPlugin *Plug);
};

/*----------------------------------------------*/
/*					Dll Export					*/
/*----------------------------------------------*/

extern "C"
{
__declspec(dllexport)	void	pinRun(TDSMPInterface*);
__declspec(dllexport)	void	pinAbort(void);
__declspec(dllexport)	void	pinNotifyEvent(DWORD Event,int Param);
__declspec(dllexport)	WAVEHDR*	pinSampling(WAVEHDR *WaveHeader);
__declspec(dllexport)	char*	pinLoadLyrics(char *Path);
__declspec(dllexport)	char*	pinOpenPlayFile(char *Path);
__declspec(dllexport)	char*	pinAddFile(char *Path);
__declspec(dllexport)	char*	pinDropFile(char *Path);
__declspec(dllexport)	void	pinKeyDown(WORD &Key,char &Shift);
__declspec(dllexport)	char*	pinLoadDesign(char *Path);
__declspec(dllexport)	DWORD	pinReceive(DWORD Cmd,DWORD Param);
}

#endif

/*****	End	*****/

